/*! PlumRx-app 2017-04-18 */
var config={
badgelevels:[
 {"id":"BEGIN","m":0,"name":"BEGIN","bg":"city","looplength":0},
 {"id":"ladybug","m":1,"name":"Ladybug","bg":"city","looplength":18,"frame":{"w":506,"h":359}},
 {"id":"dragonfly","m":4,"name":"Dragonfly","bg":"water","looplength":27,"frame":{"w":544,"h":465}},
 {"id":"blue_crab","m":8,"name":"Blue Crab","bg":"water","looplength":69,"frame":{"w":587,"h":338}},
 {"id":"bat","m":13,"name":"Flying Fox Bat","bg":"desert","looplength":51,"frame":{"w":520,"h":580}},
 {"id":"raven","m":18,"name":"Raven","bg":"mountain","looplength":40,"frame":{"w":600,"h":701}},
 {"id":"flying_dragon_lizard","m":23,"name":"Flying Dragon Lizard","bg":"jungle","looplength":13,"frame":{"w":1000,"h":358}},
 {"id":"raccoon","m":28,"name":"Raccoon","bg":"city","looplength":13,"frame":{"w":1000,"h":464}},
 {"id":"red_fox","m":36,"name":"Red Fox","bg":"desert","looplength":16,"frame":{"w":1000,"h":599}},
 {"id":"peregrine_falcon","m":44,"name":"Peregrine Falcon","bg":"city","looplength":16,"frame":{"w":1432,"h":1496}},
 {"id":"gibbon","m":52,"name":"Gibbon","bg":"jungle","looplength":33,"frame":{"w":501,"h":752}},
 {"id":"crocodile","m":60,"name":"Crocodile","bg":"water","looplength":21,"frame":{"w":1000,"h":214}},
 {"id":"lynx","m":70,"name":"Lynx","bg":"mountain","looplength":27,"multi":2,"frame":{"w":999,"h":636}},
 {"id":"red_kangaroo","m":80,"name":"Red Kangaroo","bg":"desert","looplength":17,"frame":{"w":939,"h":595}},
 {"id":"orangutan","m":90,"name":"Orangutan","bg":"jungle","looplength":17,"frame":{"w":837,"h":735}},
 {"id":"barracuda","m":100,"name":"Barracuda","bg":"water","looplength":24,"frame":{"w":996,"h":292}},
 {"id":"gray_wolf", "m":110, "name":"Gray Wolf", "bg":"mountain", "looplength":17,"frame":{"w":1016,"h":545}},
 {"id":"pygmy_elephant","m":120,"name":"Pygmy Elephant","bg":"jungle","looplength":29,"frame":{"w":1021,"h":588}},
 {"id":"camel","m":130,"name":"Camel","bg":"desert","looplength":28,"multi":2,"frame":{"w":845,"h":768}},
 {"id":"grizzly_bear","m":140,"name":"Grizzly Bear","bg":"mountain","looplength":23,"frame":{"w":1024,"h":649}},
 {"id":"ultimate","m":150,"name":"Top Explorer","bg":"ship","multi":3,"looplength":97,"frame":{"w":800,"h":467}}

],


badgelevelsfaster:[
 {"id":"BEGIN","m":0,"name":"BEGIN","bg":"city","looplength":0},
 {"id":"ladybug","m":1,"name":"Ladybug","bg":"city","looplength":10},
 {"id":"dragonfly","m":3,"name":"Dragonfly","bg":"water","looplength":9},
 {"id":"blue_crab","m":6,"name":"Blue Crab","bg":"water","looplength":10},
 {"id":"bat","m":8,"name":"Flying Fox Bat","bg":"desert","looplength":22},
 {"id":"raven","m":10,"name":"Raven","bg":"mountain","looplength":16},
 {"id":"flying_dragon_lizard","m":12,"name":"Flying Dragon Lizard","bg":"jungle","looplength":13},
 {"id":"raccoon","m":13,"name":"Raccoon","bg":"city","looplength":13,"multi":2},
 {"id":"red_fox","m":14,"name":"Red Fox","bg":"desert","looplength":16,"multi":2},
 {"id":"peregrine_falcon","m":15,"name":"Peregrine Falcon","bg":"city","looplength":16,"multi":2},
 {"id":"gibbon","m":16,"name":"Gibbon","bg":"jungle","looplength":33,"multi":2},
 {"id":"crocodile","m":17,"name":"Crocodile","bg":"water","looplength":21,"multi":2},
 {"id":"lynx","m":18,"name":"Lynx","bg":"mountain","looplength":27,"multi":2},
 {"id":"red_kangaroo","m":19,"name":"Red Kangaroo","bg":"desert","looplength":17,"multi":2},
 {"id":"orangutan","m":20,"name":"Orangutan","bg":"jungle","looplength":17,"multi":4},
 {"id":"barracuda","m":21,"name":"Barracuda","bg":"water","looplength":24,"multi":2},
 {"id":"gray_wolf", "m":22, "name":"Gray Wolf", "bg":"mountain", "looplength":17, "multi":3},
 {"id":"pygmy_elephant","m":23,"name":"Pygmy Elephant","bg":"jungle","looplength":29,"multi":5},
 {"id":"camel","m":24,"name":"Camel","bg":"desert","looplength":28,"multi":7},
 {"id":"grizzly_bear","m":25,"name":"Grizzly Bear","bg":"mountain","looplength":23,"multi":4},
 {"id":"ultimate","m":26,"name":"Top Explorer","bg":"ship","multi":3,"looplength":97,"frame":{"w":800,"h":467}}
],

badgelevelsq:[
 {"id":"BEGIN","m":0,"name":"BEGIN","bg":"city","looplength":0},
 {"id":"grizzly_bear","m":1,"name":"Grizzly Bear","bg":"mountain","looplength":24},
 {"id":"ultimate","m":2,"name":"Top Explorer","bg":"ship","multi":3,"looplength":97,"frame":{"w":800,"h":467}}

],
completeanims:{
	"size":{"w":768,"h":1024},
	
	"list":["leaves","snow","daffodil","dahlia","sunflower","tulip","wisteria","autumn"],
	
	"leaves":{"prefix":"img/complete/green_leaves_atlas","multi":1,"looplength":48},
	"snow":{"prefix":"img/complete/snow_atlas","multi":2,"looplength":48},
	"autumn":{"prefix":"img/complete/autumn_leaves_atlas","multi":2,"looplength":48},
	
	"daffodil":{"prefix":"img/complete/daffodil_atlas","multi":2,"looplength":48},
	"dahlia":{"prefix":"img/complete/dahlia_atlas","multi":2,"looplength":48},
	"sunflower":{"prefix":"img/complete/sunflower_atlas","multi":1,"looplength":48},
	"tulip":{"prefix":"img/complete/tulip_atlas","multi":2,"looplength":48},
	"wisteria":{"prefix":"img/complete/wisteria_atlas","multi":1,"looplength":48}
},

snippets:{
	"dayone":["Go on outdoor family missions! Unlock new ones every day!"],
	"daytwo":["You earned 2 new missions! Tap TODAY to see them."],
	"userprogress":["Look at everything we've completed!","Do more missions to keep leveling up!"],
	"topprogress":["Look at everything we've completed!"],
	"complete":["Mission Complete!","We Did It!","Mission Success!","Congratulations, Explorers!","%%title%% Completed!"],
	"levelup":["We leveled up!","We're making progress!"],
	"final":["You're Top Explorers!�Keep completing missions!"],
	
	"newmissions":["Every day you come here, you'll unlock 2 new missions!"],
	
	"indexgreeting":["Hello, Explorers!","Have Fun Outdoors!","Let's Explore Nature!","Head Out and Explore!","Let's Go Outside!","Head Outdoors!","Let's Explore!","Go Outside Together!","Let's Go, Explorers!","Play Outside Today!","Learn about Nature!","Walk Outside Today!","Let's Go!","Go Outside!","Explore Nature!"],
	
	"whyoutside":["Playing outside in nature helps kids do better in school!","Kids who play outdoors understand the need to protect our planet.","Kids who spend time outdoors want to keep exploring.","Outdoor activity builds children's motor skills.","Outdoor playtime is a fun way to increase family fitness.","Going outdoors releases stress. Head out and blow off some steam!","Help your immune system by going outside for some fresh air!","Doing outdoor activities stimulates creativity and imagination.","Kids who spend time outdoors keep this healthy habit as adults.","Learn to love the Earth! Learning about nature builds empathy.","Support a budding explorer! Go outside and learn together!","Build healthy habits together! ","Improve motor skills by exploring nature outdoors!","Spending time outdoors helps release excess energy."],
	
	"appmessages":["Look at ALL missions to find even more fun activities to do!","Choose \"Save Progress\" to finish a mission later.","Tap VIEW OUR PROGRESS to see past missions and badges!","Bring the app on the way to the bus!","Going for a walk in the park? Play a daily mission!","Which missions will your family do today?","Play more missions and level up!","Take photos, count things in nature, and do scavenger hunts!","Spend time outside together playing missions!","Play a daily mission and talk about nature together!","Nature is everywhere, even in cities! Pick a mission and explore!","Play a daily mission and learn about nature near you!","A few minutes can be enough time for a daily nature mission!","There's nature and science to explore outdoors, rain or shine!"]
},
completebackgrounds:[
	"teal",
	"yellow",
	"brick",
	"royalblue",
	"raspberry",
	"purp",
	"blackish"
],

trampolineconfig:{
  app_name     : 'Outdoor Family Fun with Plum',
  ua           : 'UA-47836444-6',
  guid         : 'ea045195-f17e-403f-b2ba-687017c2321b',
  moreapps     : true,
  settings     : true,
  gate         : false,
  supervision  : false,
  parents      : false,
  nav          : true,
  splash: {hide: false},
  path         : 'trampoline/dist/',
  resources    : 'trampoline/dist/'
},

intro:{
	set:['background','gabi','ship','crew','title'],
	
	background:{"image":'background_park',"w":1600,"h":900,"rest":{"x":1016}},
	gabi:{"image":'gabi_ladybug',"w":1000,"h":1331,"ladybug":{"x":15,"y":400,"w":422,"h":600}},
	crew:{"image":'plum_crew',"w":1024,"h":1172},
	title:{"image":'plum_title',"w":500,"h":350},
	ship:{"image":'window_mask',"w":1483,"h":1260,"window":{"x":674,"y":311,"w":105,"h":160}},
	
	poi:[
	[1025,110],
	[863,640],
	[681,618],
	[1080,132],
	[1217,812],
	[400,524],
	[924,434],
	[553,736],
	[1017,605],
	[1291,284],
	[845,540],
	[263,597],
	[768,290],
	[404,183],
	[1441,177],
	[1112,274],
	[680,313]
	
	],
}

};
// audio stuff. This uses the cordova Media framework. Could maybe also do SoundJS or something for it to work on web.


var sounds={
'click':{'src':'audio/click.wav'},
'sting':{'src':'audio/music_sting.wav'},
"countdown":{"src":"audio/countdown.wav"},
"countup":{"src":"audio/countup.wav"},
"levelup":{"src":"audio/levelup.wav"},
"missioncomplete":{"src":"audio/missioncomplete.wav"},
"scavengerhuntclick":{"src":"audio/scavengerhuntclick.wav"}
};
var soundtrack;
(function() {

// playsound - take in a sound id, system will find the resulting file, start time, duration, and play it.
var st={};
var nv;
st.soundcount=0;

st.preload=function(callback) {
	st.soundsneeded=7;
	nv=window.plugins.NativeAudio;
	this.afterload=callback;
	var me=this;
	
	for(var snd in sounds) {
		var sndurl=sounds[snd].src;
		nv.preloadSimple(snd, sounds[snd].src, 
			function(success){
				me.didload();
			},
			function(err){
				console.log(sndurl + ' sound error ' + err);
			});
	}
};

st.didload=function() {
	this.soundsneeded--;
	if(this.soundsneeded <=0) {
		// now ready.
		if(this.afterload) {
			this.afterload();
		}
	}
};

st.unload=function(soundid) {
	if(!nv) return;
	nv.unload(soundid);
};

st.play=function(soundid) {
	if(!app.ondevice || !nv) return;
	nv.play(soundid);
};

soundtrack=st;
}());
var tools={
	open:document.getElementById('expand'),
	enlarged:false,
	whichtool:null,
	order:['camera','counter','scavenger'],
	names:{
	'camera':"Take Photos",
	'timedcounter':"Timed Counter",
	'scavenger':"Go On A Scavenger Hunt",
	'counter':"Count Things",
	'timer':"Timer",
	'stopwatch':"Stopwatch",
	'none':"Low Tech"
	
	},
	
	showtool:function(orhide) {
		// if tool should be shown, set to open.
		
		if(!app.mission || activitydata[app.mission].tool==='none') {
			orhide=true;
		} 
		
		if(!orhide) {
		
			this.whichtool=tools[activitydata[app.mission].tool];
			
			this.smalltool();
			if(this.whichtool.launch) this.whichtool.launch(); // do this before setting the visuals, in case visuals require something
			panel.setpanel(panel.tool,activitydata[app.mission].tool,true); // sometimes this doesn't set the panel again...override with "true"
			if(this.whichtool.activate) this.whichtool.activate();
		} else {
			changeclass(panel.tool.dom,'fullopen',true);
			changeclass(panel.tool.dom,'open',true);
			// also teardown the tool
			if(this.whichtool && this.whichtool.teardown) this.whichtool.teardown();
		}
	},
	largetool:function() {

		changeclass(panel.tool.dom,'fullopen');

		cleartaps(this.open,'click',this.largetool);
		taketaps(this.open,'click',this.smalltool);
		panel.fulltool();
		this.enlarged=true;
	},
	smalltool:function() {
		changeclass(panel.tool.dom,'fullopen',true);
		changeclass(panel.tool.dom,'open');
		cleartaps(this.open,'click',this.smalltool);
		taketaps(this.open,'click',this.largetool);
		
		
		panel.fulltool(false);
		
		this.enlarged=false;
	},
	init:function() {
		this.largetool=this.largetool.bind(this);
		this.smalltool=this.smalltool.bind(this);
	}
	
};


/* CAMERA FUNCTIONS */

tools.camera={
	whichpic:0,
	lastpic:4,
	filled:false,
	progress:0, // determines the progress toward completion
	picarray:[],
	showcamera:function() {
		if(tools.enlarged) {
			this.close();
			return;
		}
		
		if(this.filled) {
			return;
		}

		this.options.allowEdit=editphoto;

		user.makecompletable(app.mission);	
		cards.checkcompletion(true);
		navigator.camera.getPicture(this.success, this.error, this.options);
	},

	options:{
		quality:75,
		correctOrientation:true,
		targetWidth:720,
		targetHeight:720, // 960 seems big enough and not too big - just under 1 megapixel... although it does make the animation a little sluggish
		saveToPhotoAlbum:true,
		allowEdit: true
//cameraDirection:Camera.Direction.FRONT [or] Camera.Direction.BACK; doesn't work on android anyway
	},
	
	success:function(image) {
		
		var im=panel.tool.ui["i"+(this.whichpic+1)];
		
		user.makecompletable(app.mission);	
		cards.checkcompletion(true);
		
		im.src=image;
		im.setAttribute("data-filled","1");
		var saveimage=image;
		if(app.ondevice) {
			var opendate=user.loadfromopenmission(app.mission,'open');
			var imagefile=app.mission + "_" + logdate(opendate,'second') + "_" + zeropad((this.whichpic+1),3) + ".jpg";
			saveimage=io.keepimage(image,imagefile);
		}


		this.picarray[this.whichpic]=saveimage;
		this.whichpic++;
		if(this.whichpic>this.lastpic) {
			this.whichpic=this.lastpic;
			this.showfilled();
		} else {
			this.showfilled(false);
		}

		var copyarray=[];
		for(var p in this.picarray) {
			copyarray.push(this.picarray[p]);
		}
		user.savetoopenmission(app.mission,'result',{'photos':copyarray});
		this.progress=this.whichpic/this.lastpic;
		
	},
	error:function(error) {
	},
	
	showfilled:function(orno) {
		var dont=(orno===false);
		this.filled=!dont;
		var o=document.getElementById('camera');
		changeclass(o,'nocamera',dont);
		cards.fullcamera(this.filled);
	},
	
	enlarge:function(ev) {
		// look at the target object's image's src, if it has one

		var im=ev.currentTarget.childNodes[0].childNodes[0];
		var filled=im.getAttribute("data-filled");
		if(!im.src || filled!=1) {this.close();return;}

		if(tools.enlarged) {
			panel.tool.ui.ilarge.src=im.src;
		} else {
			this.openup();
			panel.tool.ui.ilarge.src=im.src;
		}
	},
	openup:function() {
		tools.largetool();
		var o=document.getElementById('camera');
		changeclass(o,'close');
		changeclass(o,'nocamera',true);
		o.innerHTML='<img src="img/closex.svg" class="toolicon" />';
		tools.largetool();
		
	},
	close:function() {
		tools.smalltool();
		var o=document.getElementById('camera');
		changeclass(o,'close',true);
		changeclass(o,'nocamera',!this.filled);
		o.innerHTML='<img src="img/all_missions_camera.svg" alt="camera" class="toolicon" />';
		
	},
	init:function() {
		this.enlarge=this.enlarge.bind(this);
		this.showcamera=this.showcamera.bind(this);
		this.success=this.success.bind(this);
	},
	teardown:function() {

	},
	activate:function() {
		var r=user.loadfromopenmission(app.mission,'result');
		this.whichpic=0;
		this.picarray=[];
		if(!r) {
			this.showfilled(false);
			return;
		}
		var savedpics=r.photos;
		for(var i=0;i<=this.lastpic;i++) {
			var im=panel.tool.ui["i"+(i+1)];
			if(savedpics&&savedpics[i]) {
				this.picarray.push(savedpics[i]);
				// TESTING!
				if(!app.ondevice) {
					im.src="testimages/" + savedpics[i];
				} else {				
					im.src=io.getURL(savedpics[i]);
				}
				im.setAttribute("data-filled","1");
				im.width=100;
				im.height=100;
				changeclass(im,'userphoto');
			} else {
				im.src="img/photo_icon_empty.svg";			
				im.setAttribute("data-filled","0");
				changeclass(im,'userphoto',true);
			}
		}
		this.whichpic=this.picarray.length;
		if(this.picarray.length > this.lastpic) {
			this.showfilled();
		} else {
			this.showfilled(false);
		}
		this.progress=this.whichpic/this.lastpic;
	},
	
	results:function(id) {
		var r=user.loadfromopenmission(id,'result');
		if(r) {
			var sp=r.photos.length;
			var item=(sp===1)?'photo':'photos';
			return sp + " "+item+" taken";
		}
		return "No photos taken";
	},
	
	photoresults:function(id) {
		// show the results of a camera-type mission
		var r=user.loadfromopenmission(id,'result');
		var result='';
		if(r) {
		var savedpics=r.photos;
		result+='<div id="imgresult" class="fullctr">';
		for(var i in savedpics) {
			var src=io.getURL(savedpics[i]);
			result+="<div class=\"f1_8 col\"><img class=\"thumbnail imgresult\" src=\"" +  src + "\"></div>";
		}
		result+="</div>";
		}
		return result;
	}
};

/* COUNTER */

tools.counter={
	count:0,
	progress:0,
	subtract:function() {
		this.count--;
		this.progress=1;
		if(this.count<0) this.count=0;
		this.display();
	},
	add:function() {
		this.count++;
		this.progress=1;
		this.display();
	},
	reset:function() {
		this.count=0;
		this.progress=0;
		this.display();
	},
	
	open:function() {

		if(tools.enlarged) {
			this.close();
		} else {
		
			this.progress=1;
			
			
			user.makecompletable(app.mission);
			
			cards.checkcompletion(true); // if they open, they can complete
			var o=document.getElementById('open');
			changeclass(o,'close');
			o.innerHTML='<img src="img/closex.svg" class="toolicon" />';
			tools.largetool();
			this.hidesummary();
		}
	},
	
	close:function() {
		var o=document.getElementById('open');
		changeclass(o,'close',true);
		o.innerHTML='<img src="img/all_missions_counter.svg" class="toolicon" />';
		tools.smalltool();
		this.showsummary();
	},
	
	display:function() {
		panel.tool.ui.cdisplay.innerHTML=this.count;
		user.savetoopenmission(app.mission,'result',{'count':this.count});
	},
	init:function() {
		this.subtract=this.subtract.bind(this);
		this.add=this.add.bind(this);
		this.reset=this.reset.bind(this);
		this.open=this.open.bind(this);
	},
	activate:function() {
		var r=user.loadfromopenmission(app.mission,'result');
		if(!r || r.count==null) {
			this.progress=0;
			this.count=0;
		} else {
			this.progress=1;
			this.count=r.count;
		}
		this.updatesummary();
		this.display();
	},
	
	heroimage:function(){
		var items=activitydata[app.mission].result.split('|');
		return '<img src="img/act/'+app.mission+'_count.png" class="countimage"><h2>Count '+items[1]+'</h2>';
	},
	
	hidesummary:function() {
			changeclass(document.getElementById('summary'),'hidden');
	},
	
	showsummary:function() {
		this.updatesummary();		
		changeclass(document.getElementById('summary'),'hidden',true);
	},
	
	updatesummary:function() {
		var s=document.getElementById('summary');
		if(!s) return;
		
		var r=user.loadfromopenmission(app.mission,'result');
		var count=r?r.count:0;
		var item=this.itemname(app.mission,count);
		s.innerHTML="<span class=\"countsummary\"><span class=\"countnumber\">"+count + "</span> " + item +" counted</span>";
	},
	
	itemname:function(id,count) {
		var items=activitydata[id].result.split('|');
		var item=(count===1)?items[0]:items[1];
		return item;
	},
	
	results:function(id) {
		var count=user.loadfromopenmission(id,'result').count;
		var item=this.itemname(app.mission,count);
		return "We counted " + count + " " + item + ".";
	}
};



/* SCAVENGER HUNT */
tools.scavenger={
	progress:0,
	enlarged:false,
	checked:[],
	// make the list
	
	// look up list from current activity
	
	launch:function() {
		this.checked={};
		var arr=activitydata[app.mission].list;
		for(var a in arr) {
			this.checked[a]=false;
		}
	},
	
	lookuplist:function() {
		var arr=activitydata[app.mission].list;
		var imgarr=activitydata[app.mission].scavimgs;
		var html=this.makelist(arr,imgarr);
		return html;
	},
	
		
	statushtml:function() {
	var html='<div id="huntstatus">';
	var num=0;
		for(var a in this.checked) {
			num++;
			html+="<div class=\"statusbox\" id=\"hunt_"+num+"\"></div>";
		}
		html+="</div>";
		return html;
	},
	
	
	makelist:function(array,imagearray) {
		var html="<ul id=\"hunt\">";
		
		var useimage=imagearray!=null;
		var im='';
		for(var a in array) {
			if(useimage) {
				im='<img class="figure" src="img/act/'+app.mission+'/'+imagearray[a]+'.png" />';
			}
			html+="<li id=\"s"+a+"\"><button id=\"b_"+a+"\"><img src=\"img/hunt_checkbox_empty.svg\" class=\"checkbox\" /><span class=\"label\">" + array[a] + "</span>"+im+"</button></li>";
		}
		html+="</ul>";
		return html;
	},
	
	showlist:function() {
		
		if(tools.enlarged) {
			changeclass(document.getElementById('huntstatus'),'hidden',true);
			this.close();
		} else {
			changeclass(document.getElementById('huntstatus'),'hidden');
			user.makecompletable(app.mission);
			
			cards.checkcompletion(true);
			
			var o=document.getElementById('openlist');
			changeclass(o,'close');
			o.innerHTML='<img src="img/closex.svg" class="toolicon" />';
			tools.largetool();
		}
	},
	
	hidelist:function() {
	// switch to show list
		tools.smalltool();
	},
	
	close:function() {
		var o=document.getElementById('openlist');
		changeclass(o,'close',true);
		o.innerHTML='<img src="img/all_missions_scavenger.svg" class="toolicon" />';
		tools.smalltool();
	},
	
	togglethis:function(ev) {
		// if this one is checked, then uncheck it?
		var which=ev.currentTarget;
		var ind=which.id.replace("b_","");
		this.setthis(which,ind,!this.checked[ind]);
	},
	
	setthis:function(which,ind,checked) {
		if(checked) {
			this.checked[ind]=true;
			changeclass(which,'filled');
			which.childNodes[0].src='img/hunt_checkbox_filled.svg';
		} else {
			this.checked[ind]=false;
			changeclass(which,'filled',true);
			which.childNodes[0].src='img/hunt_checkbox_empty.svg';

		}
		this.updatestatus();
	},
	
	updatestatus:function() {
		var num=0,count,cl=0;
		var savecheck=[];
		for(var a in this.checked) {
			savecheck[a]=this.checked[a];
			if(this.checked[a]) {
				num++;
				count=document.getElementById("hunt_"+num);
				changeclass(count,'filled');
			}
			cl++;
		}
		

		this.progress=1;
		
		num++;
		for(var b=num;b<=cl;b++) {
			count=document.getElementById("hunt_"+b);
			changeclass(count,'filled',true);
		}

		user.savetoopenmission(app.mission,'result',{'found':savecheck});
		
	},

	
	teardown:function() {

	},
	init:function() {
		this.showlist=this.showlist.bind(this);
		this.togglethis=this.togglethis.bind(this);
		this.lookuplist=this.lookuplist.bind(this);
		this.statushtml=this.statushtml.bind(this);
	},
	activate:function() {
		// wire up the tool after the panel is in place
		
		var usegrid=activitydata[app.mission].scavimgs!=null;
		var d=document.getElementById('huntsection');
		changeclass(d,'grid',!usegrid);

		var getchecked=null;
		var r=user.loadfromopenmission(app.mission,'result');

		if(r && r.found) {
			this.progress=r.found.length/this.checked.length;
			getchecked=r.found;
		} else {
			this.progress=0;
		}

		for(var a in this.checked) {
			var b=document.getElementById("b_"+a);
			if(getchecked) {
				this.checked[a]=getchecked[a];
			} else {
				this.checked[a]=false;
			}
			if(b) {
				taketaps(b,'click',this.togglethis);
				b.clicksound='scavengerhuntclick';
				this.setthis(b,a,this.checked[a]);
			}
		}
	},
	
	results:function(id) {
		var r=user.loadfromopenmission(id,'result');
		var total=0;
		if(!r) return;
		for(var f in r.found) {
			if(r.found[f]) total++;
		}
		return "We found " + total + " out of " + activitydata[id].list.length;
	}
};



tools.converter={
	progress:1
};

tools.none={
	progress:1
};


/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
 
 
 /* UTILITY FUNCTIONS */
var debuglevel=0;

function debuglog(str,priority) {
	if(!priority) priority=0;
	if(priority >= debuglevel) {
		if(console) console.log(str);
	}
}

var soundsready=false;

var clickevent=new CustomEvent("didclick", 
	{
		bubbles: true,
		cancelable: true
	}
);

var jc; //jc=just counting
var topmargin=40; // WARNING MAGIC NUMBER. Was 40 px; now is related to font size, which is related to width.
var fontfactor=4.1 * 2.6;
var nosticky=true; // Android may not be able to do position:sticky, but iOS needs it.

var editphoto=false; // iOS' photo edit is OK, but Android's is a bit cumbersome


var changeclass=function(element,classname,remove) {
	if(!element) return;
	if(remove===true) {
		element.classList.remove(classname);
	} else {
		element.classList.add(classname);
	}
};

var hasclass=function(element,classname) {
	if(!element) {return;}
	return element.classList.contains(classname);
};

var toggleclass=function(element,classname) {
	if(!element) return;
	element.classList.toggle(classname);
};

var taketaps=function(element,taptype,func) {
// avoid adding the same listener multiple times

	if(!element) return;

	cleartaps(element,taptype,func);
	cleartaps(element,taptype,buttonclick);

	if(taptype=='click') {	
		setTimeout(function() {
			element.addEventListener(app.tap.down,clickdown);
			element.addEventListener(app.tap.move,clickmove);
			element.addEventListener(app.tap.up,clickup);
			element.addEventListener("didclick",func);	
			element.addEventListener("didclick",buttonclick);
		},1);
	} else {
		// delay a few ms before adding listener, to avoid picking up any currently active presses as the DOM redraws
		setTimeout(function() {
			element.addEventListener(app.tap[taptype],func);	
			element.addEventListener(app.tap.up,clickup);
		},1);
	}
};


var cleartaps=function(element,taptype,func) {
	if(!element) return;
	if(taptype=='click') {
		element.removeEventListener(app.tap.down,clickdown);
		element.removeEventListener(app.tap.up,clickup);
		element.removeEventListener(app.tap.move,clickmove);
		element.removeEventListener("didclick",func);
		element.removeEventListener("didclick",buttonclick);
	} else {
		element.removeEventListener(app.tap[taptype],buttonclick);
		element.removeEventListener(app.tap[taptype],func);
	}
};

var buttonclick=function(ev) {
	if(ev.target.clicksound && soundsready) {
		soundtrack.play(ev.target.clicksound);
	}
};

var lookup=function(id) {
	return app.globals[id];
};

var pullsnippet=function(whichset,index) {
	var snipset=config.snippets[whichset];
	if(typeof index=="undefined") {
		index=parseInt(Math.random() * snipset.length);
	}
	var str=snipset[index%snipset.length];
	return str;
};

var getfromarray=function(array) {
	var ind=parseInt(Math.random() * array.length);
	return array[ind];
};

var zeropad=function(num,digits) {
	var numstring=num.toString();
	if(!digits) digits=2;
	var count=numstring.length;
	
	if(count>=digits) return numstring;
	
	for(var i=count;i<digits;i++) {
		numstring="0"+numstring;
	}
	
	return numstring;
};

var timestamp=function() {
	// return the current time in a particular format for saving. Maybe just leave as UTC, actually
	return mydatenow().getTime();
};


var savestate=function() {
	// do this when we're about to get kicked out of memory	
};

var resumestate=function() {
	
};

var datenames={
	months:['January','February',"March",'April', 'May','June','July','August','September','October','November','December'],
	days:['Sunday','Monday','Tuesday', 'Wednesday','Thursday','Friday','Saturday']
};

var thismonth=function() {
	var d=mydatenow();
	var mnum=d.getMonth();
	return mnum;
};

var nicedate=function(datein,options) {
	// return a nice date from a timestamp
	var nice;
	var date=new Date(datein);
	if(options=='human') {
		nice=datenames.days[date.getDay()] + ", " + datenames.months[date.getMonth()] + " " + date.getDate() + ", " + date.getFullYear();
		return nice;
	}
	
	nice=(date.getMonth()+1) + "/" + date.getDate() + "/" + date.getFullYear() + " " + date.getHours() + ":" + zeropad(date.getMinutes()) + ":" + zeropad(date.getSeconds());
	return nice;
};

var logdate=function(datein,level) { // level can be 'year','month','day','hour','minute','sec'
	var date=new Date(datein);
	var nice=date.getFullYear();
	if(level!='year') {
		nice+=zeropad(1+parseInt(date.getMonth()));
		if(level!='month') {
			nice+=zeropad(date.getDate());
			if(level!='day') {
				nice+="_"+zeropad(date.getHours());
				if(level!='hour') {
					nice+="."+zeropad(date.getMinutes());
					if(level!='minute') {
						nice+="."+zeropad(date.getSeconds());
					}
				}
			}
		}
	}
	
	return nice;
};



var io={
		datadir:null,
		ready:false,
		writing:false,
		savestuff:[],
		filewriters:{},
		filereaders:{},
		getdata:function(filename,callback) {

			filename=filename+".txt";
			window.resolveLocalFileSystemURL(this.datadir,
				function(dirEntry) {		
					dirEntry.getFile(filename, {create: true, exclusive: false}, function(fileEntry) {
						io.readFile(fileEntry,callback);
					},function(error) {

						io.ready=true;
						// couldn't get the user data.	
					});
			});
		},
		
		fileExists:function(filename,success,fail) {
			filename=filename+".txt";
			window.resolveLocalFileSystemURL(this.datadir,
				function(dirEntry) {
					dirEntry.getFile(filename, {create:false,exclusive:true},
						function(fileEntry) {
							success();
						},
						function(error) {
							fail(error);
						});
				},function(error) {
					fail(error);
				});
		},
		
		listdir:function(callback) {
				
		},
		
		
		
		readFile:function(fileEntry,callback) {
			fileEntry.file(function (file) {	
			var reader = new FileReader();
			reader.onloadend = function() {
					io.ready=true;
					if(callback) {callback(this.result);}
			};
			reader.readAsText(file);
			});
		},
		
		savedata:function(data,filename) {
			this.savestuff.push([data,filename]);
			if(!this.writing) {
				this.checkformore();
			}
		},
		
		savethedata:function(data,filename) {
			io.writing=true;
			if(this.filewriters[filename]) { // already have a writer
			}
			window.resolveLocalFileSystemURL(this.datadir, function (dirEntry) {
				io.createFile(dirEntry, filename+".txt",data);
			});
		},
		
		checkformore:function() {
			if(this.savestuff.length > 0) {
				var tosave=this.savestuff.pop();
				this.savethedata(tosave[0],tosave[1]);
			} else {
				this.writing=false;
			}
		},
		
		createFile:function(dirEntry,filename,data,append){
			dirEntry.getFile(filename, {create: true, exclusive: false}, function(fileEntry) {
				io.filewriters[filename]=fileEntry;
				io.writeFile(fileEntry, data, append);
			});
		},
		
		writeFile:function(fileEntry, data, append) {
			fileEntry.createWriter(function (fileWriter) {
			fileWriter.onwriteend = function(){
				io.checkformore();
			};
			fileWriter.onerror=function() {
			};
		
			if (append) {
				try {
					fileWriter.seek(fileWriter.length);
					}
				catch (e) {
					// file doesn't exist
				}
			}

			fileWriter.write(data);
			});
		},
		
		appenddata:function(filename,data) {
			window.resolveLocalFileSystemURL(this.datadir, function (dirEntry) {
				io.createFile(dirEntry, filename+".txt",data,true);
			});
		},

		
		keepimage:function(imageuri,filename) {
			// move the image from the temp folder into a new permanent place
			this.moveFile(imageuri,this.datadir,filename);
			return filename;
		},
		
		moveFile:function(uri,newdir,filename){
			var me=this;
			window.resolveLocalFileSystemURL(uri, function(fileEntry) {
				window.resolveLocalFileSystemURL(newdir, function(dirEntry) {
					fileEntry.copyTo(dirEntry,filename,null,me.ioerror);
				},me.ioerror);
			},me.ioerror);
		},
		
		removeimage:function(imagename) {
			var imageuri=this.getURL(imagename);
			var me=this;
			window.resolveLocalFileSystemURL(imageuri, function(fileEntry) {
				fileEntry.remove();
			},me.ioerror);
		},
		
		ioerror:function(err) {
			// got a file error
		},
		
		getURL:function(filename) {
			return(this.datadir + filename);
		},
		
		init:function() {
			this.datadir=cordova.file.dataDirectory;
		}
};


 
var app = {
	// Application Constructor
	initialize: function() {
		this.bindEvents();
	},
	// Bind Event Listeners
	//
	// Bind any events that are required on startup. Common events are:
	// 'load', 'deviceready', 'offline', and 'online'.
	bindEvents: function() {
		document.addEventListener('deviceready', this.onDeviceReady, false);
		document.addEventListener('pause',this.pause, false);
		document.addEventListener('resume',this.resume,false);
		/* set up the touch/mouse mechanism */
		this.tap={};
		this.tap.down='mousedown';
		this.tap.move='mousemove';
		this.tap.up='mouseup';
		if ('ontouchstart' in document.documentElement) {
			this.tap.down='touchstart';
			this.tap.move='touchmove';
			this.tap.up='touchend';
			this.istouch=true;
		}
		
		this.tapcoords={x:0,y:0};
		this.lastcoords={x:0,y:0};


		/* get the screen size */
		this.getsize();
		
		document.addEventListener('backbutton',clickedbackbutton, false);
		this.missionproperty=this.missionproperty.bind(this);
	},


	// deviceready Event Handler
	//
	// The scope of 'this' is the event. In order to call the 'receivedEvent'
	// function, we must explicitly call 'app.receivedEvent(...);'
	onDeviceReady: function() {
		app.receivedEvent('deviceready');
		if(device.platform=='iOS') {
			nosticky=false;
		}
		app.ondevice=true;
		io.init();
		logdata.init();

		user.pulldata(); // after device is ready, load the user data.

		Trampoline.init(config.trampolineconfig);
		
		soundtrack.preload(function() {soundsready=true;});
	},
	// Update DOM on a Received Event
	receivedEvent: function(id) {
		return id;
	},
	pause:function() {
		// save position? Maybe.
		logdata.appstate('pause');
		logdata.nav('exit');
	},
	resume:function() {
		// if on the home screen, update the dashboard
		
		// "interactive" functions (example used is 'alert') need to be called with a timeout on iOS:


		if(document.getElementById('dashboard')) {
			index.refresh();
		}
		// see when user was last here - load new day if it's a new day
		
		logdata.appstate('resume');
		logdata.nav('resume');
	},
	// app methods
	// convert touch or mouse coordinates into 
	setcoords:function(ev) {
	ev.preventDefault(); // we're dragging or something, so prevent default
	this.lastcoords.x=this.tapcoords.x;
	this.lastcoords.y=this.tapcoords.y;
	this.tapcoords=getcoords(ev);
	return this.tapcoords;
	},
	getcoords:function(ev,pre) {
		if(pre) ev.preventDefault();
		if(this.istouch) {
			return {x:ev.touches[0].pageX,y:ev.touches[0].pageY};
		} else {
			return {x:ev.clientX,y:ev.clientY};
		}
	},
	
	// set main app frame size based on screen size
	getsize:function() {
		this.frame=document.getElementById('frame');
		this.width=app.frame.getBoundingClientRect().width;
		this.height=app.frame.getBoundingClientRect().height;
		this.pixelratio=100/this.width;
	},
	ondevice:false,
	
	currentid:function() {
		return this.mission;
	},
	
	missionproperty:function(prop,id) {
		if(!id) id=this.mission;
		return activitydata[id][prop];
	},

	
	globals:{},
	
	timers:{}

};

/*  USER DATA */

/*
each activity should have
- date last opened?
- status (started, finished, seen, skipped?)
- rating (after completed) - fave, positive, neutral, negative
- times completed
- (ever-growing) logs of when started and when completed.

- saved data
  - camera: pictures (URLs) (array)
  - scavenger hunt: results found (array of duples [id, found yes/no])
  - timer: time set (no saved; or possibly last time showing) (scalar)
  - stopwatch: resulting time (scalar)
  - counter: last count (scalar)
  - freeform - captured photo?

what about multi day activities?

User's overall status should have
 - list of unfinished activities
 - list of completed activities (with completion datestamp)
 - list of times using the app (maybe just update if its a new day)
 - score
 - 

*/

var logdata={
	file:{

	},
	
	fileprefix:{
		"navfile":"Nav_",
		"viewfile":"Views_",
		"launchfile":"Launch_",
		"closefile":"Completed_",
		"openfile":"Open_",
		"dailyfile":"Daily_",
		"abortfile":"Ended_"
	},
	
	nofile:{}, // for testing on web browser
	
	nav:function(nav) {
		this.appenddata("navfile",JSON.stringify([timestamp(),nav]));
	},
	
	view:function(id) {
		this.appenddata("viewfile",JSON.stringify([timestamp(),id]));
	},

	appstate:function(state) {
		this.appenddata("launchfile",JSON.stringify([timestamp(),state]));
	},
	
	newdaily:function(dailyset) {
		this.appenddata("dailyfile",JSON.stringify([timestamp(),dailyset]));
	},
	
	complete:function(data) {
		// data is a mission log - contains id (mission id), open (timestamp), done (timestamp), *result* (obj)
		this.appenddata("closefile",JSON.stringify([timestamp(),data]));
	},
	
	open:function(id) {
		this.appenddata("openfile",JSON.stringify([timestamp(),id]));
	},	
	abort:function(id) {
		this.appenddata("abortfile",JSON.stringify([timestamp(),id]));
	},
	
	appenddata:function(filename,str) {
		// just append the data to the log file
		if(app.ondevice) {
			io.appenddata(this.file[filename],str + ",\n");
		} else {
			this.nofile[this.file[filename]].push(JSON.parse(str));
		}
	},
	
	readalllogs:function(filebase,callback) {
		var n,missionlogs;
		if(app.ondevice) {
			missionlogs=user.loaddata('overall','missionlogs');
			this.logfiles=[];
			for(n in missionlogs) {
				this.logfiles.push(this.fileprefix[filebase] +missionlogs[n].toString());
			}
			this.logindex=-1;
			this.logstring="";
			this.onread=callback;
			this.trynextlogfile();
		} else {
			this.logfiles=[];
			this.logstring='';
			missionlogs=user.loaddata('overall','missionlogs');

			for(n in missionlogs) { // each n is a month YYYYMM
				var loglocation=this.fileprefix[filebase] +missionlogs[n].toString();
				var add=this.nofile[loglocation]; // an array
				if(add.length>0) {
					for(var ad in add) {
						this.logfiles.push(add[ad]);
					}
				}
			}
			callback(this.logfiles);
		}
	},
	
	trynextlogfile:function() {
		this.logindex++;
		var me=this;
		
		if(this.logindex >= this.logfiles.length) {
			this.gotarraydata(this.logstring);
		} else {	
			var filename=this.logfiles[this.logindex];
			var success=function() {io.getdata(filename,me.gotpartiallogdata);};
			var failure=function() {me.trynextlogfile();};
			io.fileExists(filename,success,failure);
		}
	},
	
	gotpartiallogdata:function(string) {
		this.logstring+=string;
		this.trynextlogfile();
	},
	
	readlog:function(filename,callback) { // read the log in as if it were an array
		this.onread=callback;
		if(app.ondevice) {
			var me=this;
			var whattodo=function() {io.getdata(me.file[filename],me.gotarraydata);};
			var tryanother=function() {};
			io.fileExists(this.file[filename],whattodo,tryanother);
		} else {
			callback(this.nofile[this.file[filename]]);
		}
	},
	
	fixarray:function(str) {
		str="["+str.substr(0,str.length-2)+"]";
		return str;
	},
	
	gotarraydata:function(datastring) {
		this.onread(JSON.parse(this.fixarray(datastring)));
	},
	
	groupbydate:function(logasarray) {
		var dategrouping=[];
		var oldday,logentry,datecount=-1;

		for(var i in logasarray) {
			// datestamp is the first entry
			logentry=logasarray[i];
			console.log("logentry " + logentry + " " + logdate);
			var newday=logdate(logentry[0],'day');
			if(oldday!=newday) {
				datecount++;
				oldday=newday;
				var entrydate=logentry[0]; 
				dategrouping[datecount]={'date':nicedate(entrydate,'human'),'dateid':newday,'acts':[]};
			}
			dategrouping[datecount].acts.push(logentry[1]);
		}
		return dategrouping;
	},
	
	pullmissionid:function(logasarray,id) {
		var newarray=[];
		var i,it;
		
		for(i in logasarray) {
			it=logasarray[i];
			if(it[1].id==id) {
				newarray.push(it);
			}
		}
		return newarray;
	},
	
	setnewlogfiles:function(datestring) {
		var f;
		if(!app.ondevice) {
			for(f in this.fileprefix) {
				this.nofile[this.fileprefix[f] + datestring]=[];
			}
		} 

		for(f in this.fileprefix) {
			this.file[f]=this.fileprefix[f] + datestring;
		}
	},
	
	init:function() {
		this.gotarraydata=this.gotarraydata.bind(this);
		this.gotpartiallogdata=this.gotpartiallogdata.bind(this);
	}
};

var user={
	activitysaved:{},
	tempdata:{}, // save to a temp file so that it's small and responsive while making changes, then pull the full history later? Maybe should log by...month? User needs a complete list though.
	filename:"Userdata",
	tempfile:"temp",
	statclick:0, // click several times to show stats

	missionstatus:{ // set of arrays for condition of each mission 
		completed:[],
		open:[],
		seen:[],
		fave:[]
	},
	status:{
		unseen:0,
		seen:1,
		open:2,
		done:3
	},
	rating:{
		fave:3,
		pos:2,
		mid:1,
		neg:0
	},
	
	
	// openmissions shows all missions the user has ever seen - some will be completed, others started but not completed, others never begun.

	showstatus:function(activityid) {

		var miss=this.loaddata(activityid);
		if(!miss) return this.status.unseen;
		if(miss.status) {
			return miss.status;
		}
		return this.status.unseen;
	},
	

	
	showopendate:function(activityid) {
		
		var miss=this.loaddata(activityid);
		
		if(miss.open) {
			return miss.open.open;
		}
		return null;
	},
	
	updatemissionlists:function() {
		// go through missions and send the counts of each
		this.missionstatus.seen=[];
		this.missionstatus.open=[];
		this.missionstatus.completed=[];
		
		for(var id in activitydata) {
			var status=this.showstatus(id);
			switch(status) {
				case this.status.seen:
				this.missionstatus.seen.push(id);
				break;
				
				case this.status.open:
				var date=this.showopendate(id);
				date=new Date(date).getTime();
				this.missionstatus.open.push([date,id]);
				break;
				
				case this.status.done:
				this.missionstatus.completed.push(id);
				break;
			}
		}
		// sort missionstatus by date opened...
		this.missionstatus.open=this.missionstatus.open.sort(function(a,b){return(b[0] - a[0]);});
	},
	
	setmissionopen:function(activityid,isopen,defer) {
		var val={open:timestamp(),done:null};
		if(!isopen) val=null;
		
		this.savedata(activityid,'open',val,defer);
	},
	
	savetoopenmission:function(activityid,key,value,defer) {
		// open mission is the last one in the log file
		var om=this.loaddata(activityid,'open');
		if(om) {
			om[key]=value;
		}
		this.savedata(activityid,'open',om,defer);
	},
	
	loadfromopenmission:function(activityid,key) {
		var om=this.loaddata(activityid,'open');

		if(!om) return null;	
		om.id=activityid;
		if(key) {
			return om[key];
		}
		return om;
	},

	seemission:function(activityid) {
		// this mission has been PRESENTED to the user as a daily activity
		
		var checkmission=this.loaddata(activityid);

		if(!checkmission || !checkmission.hasOwnProperty('status')) {
				// brand new one
			checkmission={'status':this.status.seen,'seen':1,'opened':0,'closed':0,'canceled':0,'fave':false,'open':null,'canclose':false};
			this.savedata(activityid,null,checkmission,true);
		} else  {
			checkmission.seen++;
			if(checkmission.status!=this.status.open && checkmission.status!=this.status.done) {
				checkmission.status=this.status.seen;
			}
		}


// log this in viewed missions
		logdata.view(activityid);
		this.writedata();
	},

	openmission:function(activityid) {
		// user has opened a mission
		
// put this mission in the list of open missions unless it's already there
		var newopen=true;
		
		var checkmission=this.loaddata(activityid);

		var repeat=false;
		if(!checkmission || !checkmission.status) { // first time opening this mission
			checkmission={'status':this.status.open,'seen':1,'opened':1,'closed':0,'canceled':0,'fave':false,'open':{},"canclose":false};
		} else if(checkmission.status != this.status.open) {
		// This mission has been seen/saved/opened before, but is not currently open
		
			if(checkmission.closed > 0) {
				 repeat=true;
			}
			checkmission.status=this.status.open;
			checkmission.opened++;
			checkmission.canclose=false;
			checkmission.open={};
		} else {
		// this mission is currently already open; don't timestamp a new opening, but DO timestamp for last opened
			newopen=false;		
			this.savetoopenmission(activityid,'lastopen',timestamp(),true);
		}
		
		if(newopen) {

			if(repeat) {
				track("event",{category:"Mission Replay",action:activityid,label:nav.lastlist});
			} else {
				track("event",{category:"Mission Started",action:activityid,label:nav.lastlist});
			}
		
			logdata.open(activityid);


			this.savedata(activityid,null,checkmission,true);
			this.setmissionopen(activityid,true,true);
			this.dailycredit('open',true);
			
		} 
		this.writedata();
	},
	
	iscompletable:function(activityid) {
		if(this.loaddata(activityid,'canclose')) return 1;
		return 0;
	},
	
	makecompletable:function(activityid) {
		this.savedata(activityid,'canclose',true);
	},
	

	isfave:function(activityid) {
		return this.loaddata(activityid,'fave');
	},
	
	setfavemission:function(activityid,tf) {
		this.savedata(activityid,'fave',tf);
	},

	
	togglefave:function(activityid) {
		var isfave=this.loaddata(activityid,'fave');
		this.setfavemission(activityid,!isfave);
		return !isfave;
	},
	
	abortmission:function(activityid) {
		var checkmission=this.loaddata(activityid);
		if(!checkmission) return;
		checkmission.canceled++;
		if(app.ondevice && activitydata[activityid].tool=='camera') {
			// notify that (at least one) gallery is available on this mission
			var res=this.loadfromopenmission(activityid,'result');
			if(res && res.photos && res.photos.length > 0) {
				for(var ph in res.photos) {
					io.removeimage(res.photos[ph]);
				}
			}
		}
		checkmission.status=this.status.seen;
		checkmission.open=null;
		this.savedata(activityid,null,checkmission);
		logdata.abort(activityid);

	},
	
	completemission:function(activityid) {
	
		var me=this;
		
		
		this.savedata(activityid,'status',this.status.done,true);

		if(activitydata[activityid].tool=='camera') {
			// notify that (at least one) gallery is available on this mission
			var res=this.loadfromopenmission(activityid,'result');
			if(res && res.photos && res.photos.length > 0) {
				this.savedata(activityid,'hasgallery',true,true);
			}
		}
// stop the timer for this mission if it's running

		var checkmission=this.loaddata(activityid);
		
		var userlevel=this.loaddata('overall','level');
		
		if(!userlevel) userlevel=0;


		var tm=this.loaddata('overall','totalmissions');
		if(!tm) tm=0;
		this.savetoopenmission(activityid,'done',timestamp(),true);
		
		checkmission.closed++;

		this.savedata('overall','totalmissions',tm+1,true);
			
		this.savedata('overall','level',userlevel);

		var closedmission=this.loadfromopenmission(activityid);

// give credit for having done something today		
		this.dailycredit('done',true);
		
		this.setmissionopen(activityid,false,true);
		
		var stat=user.getbadgestatus();			
		var pdone=1*stat.progress;
		
		var ok=document.getElementById('okay');
		changeclass(ok,'hidden');
		var avtap=function() {
			cleartaps(ok,'click',avtap);
			changeclass(document.getElementById('complete'),'bg-'+me.completeset.bg,true);
			changeclass(document.getElementById('complete'),'bg-' + stat.next.bg);
			
			changeclass(document.getElementById('cbg'),'bg-' + stat.current.bg);
			changeclass(document.getElementById('cbg'),'hidden',true);
			cards.changeavatar(stat.current,stat.next);
		};
		
		var levelornot="Congratulations";
		
		if(this.checkfornewlevel()) {
			stat.current.level=parseInt(stat.level);
			stat.next.level=parseInt(stat.level)+1;
			closedmission.badge=stat.next;
			levelornot="Level Up";
			taketaps(ok,'click',avtap);
		} else {
			taketaps(ok,'click',nav.home);
		}
		
		logdata.complete(closedmission); // have to do after badge is set in checkfornewlevel above
		
		
		
		var loadarray=[];
	
		var anim=getfromarray(config.completeanims.list);//"leavessmall";
		var cset=config.completeanims[anim];
		this.completeset={
			anim:anim,
			prefix:cset.prefix,
			multi:cset.multi,
			looplength:cset.looplength,
			bg:config.completebackgrounds[parseInt(Math.random() * config.completebackgrounds.length)]
		};
	
	
		changeclass(document.getElementById('complete'),'bg-' + this.completeset.bg);
	
		var pre;
		if(!this.completeset.multi || this.completeset.multi==1) {
			this.completeset.multi=1;	
			pre=this.completeset.prefix + ".json";
			if(!animation.alreadyloaded(pre)){
				loadarray.push(pre);
			}
			
		} else {
			for(var p=0;p<this.completeset.multi;p++) {
				pre=this.completeset.prefix + p + ".json";
				if(!animation.alreadyloaded(pre)){ 
					loadarray.push(pre);
				}
			}
		}
		


		animation.clear();
		
		
		changeclass(document.getElementById('complete'),'bg-' + anim);
		
		animation.resize(app.width,app.height);
		
		if(loadarray.length <1) {
			me.completeanimready();
		} else {
			animation.load(loadarray, function() {me.completeanimready();});
		}		
		
		setTimeout(function() {
			// after the animation plays, slide up the bottom

			var fo=document.getElementById('finishedblurb');
			changeclass(fo,'up');
			setTimeout(function() {
				cards.moveprogress(pdone);
				changeclass(ok,'hidden',true);
			},1500);
		},1500);
		
		track('event',{category:"Mission Completed",action:activityid,label:levelornot});
	},
	
	
	completeanimready:function() {
	
	
		soundtrack.play('missioncomplete');
		var sheetset;
		if(this.completeset.multi==1) {
			sheetset=animation.multiframes({'only':this.completeset.prefix});

		} else {
			sheetset=animation.multiframes({'prefix':this.completeset.prefix});
		}		
		var sw=document.getElementById('animlayer');
		sw.innerHTML="";
		sw.appendChild(animation.dom);
		
		var smscale=2;
		var origwidth=config.completeanims.size.w/smscale;  // was 640x1136..
		var origheight=config.completeanims.size.h/smscale; // now is 768x1024?

		
		var widthscale=animation.width/origwidth;
		var heightscale=animation.height/origheight;

		animation.addsprite({
			multiframes:sheetset,
			position:{x:app.width/2,y:app.height/2},
			scale:{x:widthscale,y:heightscale},
			looplength:this.completeset.looplength,
			frame:0,loop:-1
		});
	
		animation.animate();
	},
	

	savedata:function(activityid,key,value,defer) {
		var savezone;
		
		if(activityid==='overall') {
			savezone=this.activitysaved;
		} else {
			if(!this.activitysaved.openedmissions) {
				this.activitysaved.openedmissions={};
			}
			savezone=this.activitysaved.openedmissions;
		}
		
		if(!savezone[activityid]) {
			savezone[activityid]={};
		}
		if(key) {
			savezone[activityid][key]=value;
		} else {
			savezone[activityid]=value;
		}
		if(!defer) {
			this.writedata();
		}

		this.updatemissionlists();

	},
	writedata:function() {
		if(app.ondevice) {
			this.savetodevice();
		}
	},
	
	loaddata:function(activityid,key) {
		var savezone;
		if(activityid==='overall') {
			savezone=this.activitysaved;
		} else {
			if(!this.activitysaved.openedmissions) {
				this.activitysaved.openedmissions={};
			}
			savezone=this.activitysaved.openedmissions;
		}
		if(!savezone[activityid]) {
			savezone[activityid]={}; // create new?
			return null;
		}
		if(key) {
			return savezone[activityid][key];
		}
		return savezone[activityid]; // otherwise return everything
	},
	
	savetodevice:function() {
		var str=JSON.stringify(this.activitysaved);
		io.savedata(str,this.filename);
    },
	
	pulldata:function() {
		this.activitysaved={};
		io.getdata(this.filename,this.setdata);
	},
	
	setdata:function(data) {
		if(data) {
			data=JSON.parse(data);
			this.activitysaved=data;
		}
		this.checkfornewmissions();
		this.whichdailies(lists.length);
		this.updatemissionlists();
		index.refresh();
	},
	
	cleardata:function() {

		this.activitysaved={};
		if(app.ondevice) {	
			io.savedata(JSON.stringify(this.activitysaved),this.filename);
		}
		this.updatemissionlists();
	},
	
	whichdailies:function(length) {
		var lastdailyset=this.loaddata('overall','dailyset');

		var date=new Date(mydatenow());
		var set={'last':0,'year':date.getFullYear(),'month':date.getMonth()+1,'day':date.getDate()};
		
		if(!lastdailyset) {
			this.savedata('overall','dailyset',set);
			this.savedata('overall', 'clickedtoday',false);
			logdata.newdaily(lists[0]);
			return 0;
		} else {
			
		
			if(lastdailyset.year == set.year && lastdailyset.month == set.month && lastdailyset.day == set.day) { // same day as before
			
				return parseInt(lastdailyset.last);
			} else {
				var nx=parseInt(lastdailyset.last)+1;
				if(nx >= length) nx=0;
				set.last=nx;
				
				this.savedata('overall','dailyset',set,true);
				this.savedata('overall', 'clickedtoday',false);
				// new daily set!
				logdata.newdaily(lists[nx]);
				// reset the card carousel position to the first card
				cards.newcarousel();
				return nx;
			}
		}	
	},
	
	checkfornewmissions:function() {
		var missiondaylist=this.loaddata('overall','missiondays');
		var count=-1;
		var i;
		for(var jc in missiondaylist) {
			count++;
		}
		
		var missiondaycount=this.loaddata('overall','whichday');
		
		if(missiondaycount==null) {
			missiondaycount=-1;
		}


		if(count >= missiondaycount) {
		// get new missions
			if(count > missiondaycount) {
				this.savedata('overall','whichday',count);
			}
			newmissions={};
			missionstouse=[];
			var last=Math.min(count,rollout.length-1);
			for(i=last;i>=0;i--) {
				var batch=rollout[i];
				for(var id in batch) {
					var m=batch[id];
					if(newmissions[m]===undefined) {
						missionstouse.push(m);
					}
					if(i==count && count>0) {
					// these ones are all marked "new" and should be at the top, but not on day 1 (when count==0)
						newmissions[m]=true;
					} else {
						newmissions[m]=false;
					}
				}
			}
		}
		
	},
	
	levelup:function() {
		return pullsnippet('levelup');
	},
	
	encouragement:function() {
		if(user.getcurrentbadge().id=="ultimate") {
			return pullsnippet('topprogress');
		} else {
			if(!this.whichprogress) {
				this.whichprogress=0;
			}
			var sn=pullsnippet('userprogress',this.whichprogress);
			this.whichprogress++;
			return sn;
		}
	},
	
	completemessage:function() {
		var snip=templates.parse(pullsnippet('complete',4),{'title':app.missionproperty});
		return snip;
	},
	
	maybebadge:function() {
		if(this.getbadgenumber() > 0) {
			return templates.parse(templates.badge.html,templates.badge.subs);
		}
		return "";
	},
	
	getbadgeimage:function() {
		var stat=user.getbadgestatus();
		return badges.heximagesrc(stat.current);
	},
	
	getbadgenumber:function() {
		var stat=user.getbadgestatus();
		return parseInt(stat.level);
	},
	
	getmissionresults:function(missionid,callback) {
		// go through the log of all completed missions and pull out the one with this mission id. for gallery

		logdata.readalllogs('closefile',function(dataobj) {
			var d=logdata.pullmissionid(dataobj,missionid);
			callback(d);
		});
	},
	
	getcurrentbadge:function() {
		var ul=this.loaddata('overall','level');
		return config.badgelevels[parseInt(ul)];
	},
	
	getbadgestatus:function() {
	
		var l=this.loaddata('overall','totalmissions');
		var ul=this.loaddata('overall','level');
		
		if(!ul) {
			ul=0;
		}
		if(!l) {
			l=0;
		}
		l=parseInt(l);
		ul=parseInt(ul);
		var currentbadge=config.badgelevels[ul];
		var baseline=currentbadge.m;
		var nextbadge=config.badgelevels[parseInt(ul)+1];
		var progress=1;
		
		if(nextbadge){
			progress=((l-baseline)/(nextbadge.m-baseline));
		} else {
			nextbadge=currentbadge;
		}
		
		return {'progress':progress, 'current':currentbadge, 'next':nextbadge, 'level':ul};
	},
	
	checkfornewlevel:function(defer) {
		var totalmissions=parseInt(this.loaddata('overall','totalmissions'));
		var userlevel=parseInt(this.loaddata('overall','level'));
		
		var nextlevel=0;
		for(var badgelevel in config.badgelevels) {
			var missionsforbadge=parseInt(config.badgelevels[badgelevel].m);
			if(missionsforbadge > totalmissions) {
				break;
			}
			nextlevel=badgelevel;
		}

		
		if(nextlevel > userlevel) { // level up!
			this.savedata('overall','level',nextlevel,defer);
			return true;
		} else {
			return false;
		}
	},
	
	dailycredit:function(type,defer) {
		// give the user credit for doing something this day
		var missiondays=this.loaddata('overall','missiondays');
		
		if(!missiondays) {
			missiondays={};
		}
		var counted=0;
		var t=mydatenow();
		var dt=new Date(t);
		var tm=dt.getHours() + ":" + zeropad(dt.getMinutes());
		var today=logdate(t,'day');
		var isnew=false;
		if(missiondays[today]) {
			missiondays[today].last=tm;
			if(type=='done') missiondays[today].done++;
		} else {
			// a new day!
			missiondays[today]={'start':tm,'last':tm,'done':0};
			isnew=true;
		}
		
		if(isnew || type!='any') {
			this.savedata('overall','missiondays',missiondays,defer);
			if(isnew) {
				counted=0;
				for(var jc in missiondays) {
					counted++;
				}
				this.checkfornewmissions();
				this.addtologfiles(logdate(mydatenow(),'month'));

				track('event',{category:'Days',action:"New Day",label:counted});
			}
		}
	},
	
	addtologfiles:function(datestring) {
		var missionlogs=this.loaddata('overall','missionlogs');
		if(!missionlogs) {missionlogs=[];}
		for(var st in missionlogs) {
			if(missionlogs[st]===datestring) {
				return;
			}
		}
		missionlogs.push(datestring);
		this.savedata('overall','missionlogs',missionlogs);
		logdata.setnewlogfiles(datestring);
	},
	
	
	
	init:function() {

		this.cleardata=this.cleardata.bind(this);
		this.setdata=this.setdata.bind(this);
		
		this.maybebadge=this.maybebadge.bind(this);

		this.addtologfiles(logdate(mydatenow(),'month'));
	
	}
};

user.init();


var panel={
	topnav:{dom:document.getElementById("topnav"),ui:{}},
	content:{dom:document.getElementById("content"),ui:{}},
	tool:{dom:document.getElementById("tool"),ui:{}},
	bottomnav:{dom:document.getElementById("bottomnav"),ui:{}},

	home:document.getElementById('homebtn'),
	
	
	setpanel:function(whichpanel,template,force) {
		var t=templates[template];

		if(whichpanel.active===template && !force) return; // this template has already been set, so don't set again (overriden by setting force to true)
		whichpanel.active=template;
		templates.subs=t.subs;


		changeclass(panel.content.dom,'daily',true);

		whichpanel.dom.innerHTML=templates.parse(t.html);
		// set up buttons
		whichpanel.ui={}; // clear old UI out
		
		if(whichpanel==this.bottomnav) {
	// special case! d'oh. Carousel is bigger w/ no background
			changeclass(whichpanel.dom,'tall',template!='carousel');
			var nobg=(template=='carousel' || t.nobg);
			changeclass(whichpanel.dom,'bg-grey',nobg);
		}
		
		for(var bid in t.buttons) {
			var bconf=t.buttons[bid];
			whichpanel.ui[bid]=document.getElementById(bid);
			for(var b in bconf) {
				if(b=='tap') {
					taketaps(whichpanel.ui[bid],'click',bconf[b]);
				}
				if(b=='clicksound') {
					whichpanel.ui[bid].clicksound=bconf[b];
				}
			}
		}
	},
	

	showpanel:function(whichpanel,doshow) {
		if(doshow===false) {
			changeclass(whichpanel.dom,'hidden');
		} else {
			changeclass(whichpanel.dom,'hidden',true);
		}
	},
	
	fullscreen:function() {
		this.showpanel(this.topnav,false);
		this.showpanel(this.bottomnav,false);
		tools.showtool(true);		
		this.showpanel(this.tool,false); // actually hide the tool first
		changeclass(this.content.dom,'list',true);
		changeclass(this.content.dom,'fullscreen');
		pastscroll(false);
	},
	
	shownav:function() {
		this.showpanel(this.topnav,true);
		this.showpanel(this.bottomnav,true);
		this.showpanel(this.tool,true);
		
		changeclass(this.content.dom,'list',true);
		changeclass(this.content.dom,'fullscreen',true);
		pastscroll(false);
	},
	
	showtopnav:function() {
		this.showpanel(this.topnav,true);
		this.showpanel(this.bottomnav,false);
		this.showpanel(this.tool,false);
		changeclass(this.content.dom,'list',true);
		changeclass(this.content.dom,'fullscreen',true);
		changeclass(this.content.dom,'tool',true);
		pastscroll(false);
	},
	
	fulltool:function(orfalse) {
		this.showpanel(this.topnav,(orfalse===false));
		this.showpanel(this.bottomnav,(orfalse===false));
	},
	
	showlist:function() {
		changeclass(this.content.dom,'list');
		changeclass(this.content.dom,'fullscreen',true);
	},

	init:function() {
	},
};

panel.init();


/* GET ACTIVITY DATA */

var activitydata; // hash of activiy info
var lists; // list of groups of five to mete out
var rollout; // list of activities to roll out by day
var allids; // list of all ids

var missionstouse; // list of missions to actually show in various lists
var newmissions; // hash of new missions

var minprogwidth=220; 
var progiconwidth=44;
var progresswidth=minprogwidth-(progiconwidth*2);

var loadactivities=function(url,success) {
		if(!url) {
			url='js/activities.json';
		}

		var rq=new XMLHttpRequest();
		rq.open("GET",url,true);
		rq.onreadystatechange=function() {
			if(rq.readyState === XMLHttpRequest.DONE) {
			success(rq.responseText);
			}
		};
		
		rq.send();
};


loadactivities('js/activities.json',function(responseText) {
	var ad=JSON.parse(responseText);
	activitydata=ad.activities;
	allids=[];
	for(var l in activitydata) {
		allids.push(l);
	}
	lists=ad.daily;
	rollout=ad.rollout;
	
	cards.drawcards(user.whichdailies(lists.length));

	user.updatemissionlists();
});




/* LOAD TEST DATA */

var loadtestdata=function(url,success) {
		var rq=new XMLHttpRequest();
		rq.open("GET",url,true);
		rq.onreadystatechange=function() {

			if(rq.readyState === XMLHttpRequest.DONE) {
			success(rq.responseText);
			}
		};
		rq.send();
};



var gottestdata=function(testdata) {
		
		// add the log info to the nonfile log tables

		testdata=JSON.parse(testdata);
		
		user.setdata(JSON.stringify(testdata.Userdata));		

		for(var li in testdata.logs) {
			var lf=testdata.logs[li];
			for(var d in lf) {
				var logname=d;
				// make a new fake log if it isn't there already
				if(!logdata.nofile[logname]) {
					logdata.nofile[logname]=[];
				}
				for(var log in lf[d]) {
					logdata.nofile[logname].push(lf[d][log]);
				}
			}
		}
		user.checkfornewmissions();
};



/* INDEX PAGE */

var index={
	bgs:{},

	refresh:function() {
		this.activate();
	},
	
	finishlist:function() {
		nav.list('open');
	},
	
	finishsingle:function() {
		nav.single(user.missionstatus.open[0][1]);	
	},
	
	allcompleted:function() {
		nav.list('completed');
	},
	
	fulllist:function() {
		nav.list();
	},

	activate:function() {
		
		// set backgrounds
		var bg1=document.getElementById('index');
		if(bg1) {
		var bstyle="background-size:"+(this.bgs.outside.size.x) + "px " +(this.bgs.outside.size.y) +"px ; background-position: "+this.bgs.outside.pos.x+"px " +this.bgs.outside.pos.y +"px;";
		bg1.setAttribute('style',bstyle);
		
		var bg2=document.getElementById('ship');
		bstyle="background-size:"+(this.bgs.ship.size.x) + "px " +(this.bgs.ship.size.y) +"px ; background-position: "+this.bgs.ship.pos.x+"px " +this.bgs.ship.pos.y +"px;";
		bg2.setAttribute('style',bstyle);


		bg1.style.backgroundPosition=this.bgs.outside.pos.x+"px " +this.bgs.outside.pos.y +"px;";

		}
		

		var todaybutton=document.getElementById('todaymissions');
		if(todaybutton) {
			taketaps(todaybutton,'click',nav.cards);
			if(!user.loaddata('overall', 'clickedtoday')) {
				changeclass(todaybutton,'newtoday');
			} else {
				changeclass(todaybutton,'newtoday',true);
			}
		}
		
		var progressbutton=document.getElementById('inprogress');
		if(progressbutton) {
			var count=user.missionstatus.open.length;		
			changeclass(progressbutton,'disabled',count > 0);
			if(count>0) {
				cleartaps(progressbutton,'click',this.finishsingle);
				taketaps(progressbutton,'click',this.finishlist);
				progressbutton.innerHTML="In Progress (" + count +")";
			} else {
				progressbutton.innerHTML="In Progress";
				cleartaps(progressbutton,'click',this.finishlist);
				cleartaps(progressbutton,'click',this.finishsingle);
			}
		}
		
		var allbutton=document.getElementById('allmissions');
		if(allbutton) {
			taketaps(allbutton,'click',this.fulllist);
		}
		
		var dashzone=document.getElementById('dashboard');
		if(dashzone) dashzone.innerHTML=this.getdashboard();
		
		var plumimage=document.getElementById('plum');
		
		var historybutton=document.getElementById('history');
		if(historybutton) {
			taketaps(historybutton,'click',this.allcompleted);
		}
		
	},
	
	dashmessage:function() {
		var message;
		
		var lw=user.loaddata('overall', 'lastwelcome');
		var messageindex;

		if(lw!='whyoutside') {
				messageindex=user.loaddata('overall','message1index');
				messageindex=(messageindex==null)?-1:parseInt(messageindex);
				messageindex++;
				lw='whyoutside';
				message=pullsnippet('whyoutside',messageindex);
				messageindex=user.savedata('overall','message1index',messageindex,true);
			} else {
				messageindex=user.loaddata('overall','message2index');
				messageindex=(messageindex==null)?-1:parseInt(messageindex);
				messageindex++;
				lw='appmessages';
				message=pullsnippet('appmessages',messageindex);
				messageindex=user.savedata('overall','message2index',messageindex,true);
			}
			
		user.savedata('overall','lastwelcome',lw,true);
		return message;
	},
	
	getdashboard:function() {
		// look up user's history
		
		var c=user.loaddata('overall','totalmissions');
		if(!c) c=0;
		
		
		// greeting can change based on whether user has been here before, time of day, weather..?
		
		var greeting;
		
		var today=new Date(mydatenow());
		var tod=today.getHours();


			if(tod < 4) {
				greeting="Go to sleep!";
			} else if(tod < 12) {
				greeting="Good morning!";
			} else if(tod < 17) {
				greeting="Good afternoon!";
			} else if(tod < 20) {
				greeting="Good evening!";
			} else if(tod < 24) {
				greeting="Ah, nighttime!";
				}
			
		var dash='';
		var welcomemessage="";
		var md=user.loaddata('overall','whichday');

		if(!md || md < 2) { // less than two days!
			greeting="Welcome, Explorers!";		
			welcomemessage=pullsnippet("dayone");
			
			if(md) {
				// been here before 
				greeting="Welcome Back!";
				if(!this.sawsecond) {
					 welcomemessage=pullsnippet("daytwo");
					 this.sawsecond=true;
				} else {
					welcomemessage=this.dashmessage();
				}
			}
		} else {
			
			welcomemessage=this.dashmessage();

			if(Math.random()>=0.25) {
				greeting=pullsnippet('indexgreeting');
			}
		}


		dash+='<img src="img/plum_index.svg" alt="Plum" id="plum"/>';
		dash+="<h1>"+greeting+"</h1>";
		dash+="<div id=\"welcome\">"+welcomemessage+"</div>";
		
		
		
		if(c>0) {
			var shownewprogress="";
			if(!user.loaddata('overall', 'clickedprogress')) {
				shownewprogress=" newprogress";				
				user.savedata('overall', 'clickedprogress',true); // only show this one time ever
			}
			dash+='<a id="history">' + progressbar() + '<span class="progresstext '+shownewprogress+'" id="viewprogress">View our progress</span></a>';
		} else {
			dash+=progressbar();
		}
		
		// also set the mission date
		var dd=document.getElementById('today');
		if(dd) {
			dd.innerHTML=datenames.months[today.getMonth()] + " " + today.getDate();
		}

		return dash;
	},
	
	init:function(){
		this.activate=this.activate.bind(this);
		this.allcompleted=this.allcompleted.bind(this);
	},
	
	porthole:function(ind) {
		var bg1=document.getElementById('index');

		if(bg1) {
			if(ind==null) ind=parseInt(Math.random() * config.intro.poi.length);
			var osc=this.bgs.outside.scale;
			var ssc=this.bgs.ship.scale;
			var poi=config.intro.poi[ind];
			var x=poi[0]*-1*osc + app.width - (ssc*config.intro.ship.window.w/2);
			var y=poi[1]*-1*osc + (ssc*config.intro.ship.window.h/2);
			bg1.style.backgroundPosition=x + "px "+y+"px";
		}
	}
};


var progressbar=function() {
	// find user's animal and the next animal in sequence.
	
	// circle on the left side, covered by an image; circle on the right covered by a 
	
	var w=progresswidth; // width of the bar itself

	var stat=user.getbadgestatus();
	
	var h=10; // height of the bar
	var pdone=stat.progress; //0.8;

	var w2=w*pdone;
	var r=21; // radius of the icons
	var r3=10; // radius of the little circle "nub"
	var d=r*2;
	var ly=r-(h/2);
	var linecolor="#311C79";
	var greycolor="#dedede";


	var sv='<div class="ctr" id="progress"><svg id="badgedisplay" viewBox="0 0 '+(d*2+w)+' 44"><g>\
	<rect width="'+(w)+'" height="'+h+'" x="'+d+'" y="'+ly+'" fill="'+greycolor+'"/>';
	sv+='<rect width="'+h+'" height="'+h+'" x="'+(d-h)+'" y="'+ly+'" fill="'+linecolor+'" /><rect width="'+h+'" height="'+h+'" x="'+(d+w)+'" y="'+ly+'" fill="'+greycolor+'" />\
	<rect id="fillline" width="'+w+'" style="-webkit-transform: scaleX('+pdone+'); transform: scaleX('+pdone+');" height="'+h+'" x="'+d+'" y="'+ly+'" fill="'+linecolor+'" />';

	if(stat.level===0) {
		sv+='<circle id="nub" cx="'+(d-h)+'" cy="'+r+'" r="'+r3+'" fill="'+linecolor+'" /></g></svg>';
		sv+='<img height="44" width="44" class="progressicon" id="avatarempty" src="'+badges.silhouetteimagesrc(stat.next)+'" style="right:0px;" /></div>';
	} else if(stat.current.id=='ultimate') { // last level: user's avatar is on the RIGHT side now
		sv+='<circle id="nub" cx="'+r+'" cy="'+r+'" r="'+(r-4)+'" fill="'+linecolor+'" /></g></svg>';
		sv+='<img height="44" width="44" class="progressicon" id="avatarempty" src="'+badges.progressimagesrc(stat.current)+'" style="right:0px;"></div>';		
		
	} else {
		sv+='</g></svg><img height="44" width="44" class="progressicon" id="avatar" src="'+badges.progressimagesrc(stat.current)+'" style="left:0px" />';
		sv+='<img height="44" width="44" class="progressicon" id="avatarempty" src="'+badges.silhouetteimagesrc(stat.next)+'" style="right:0px;"></div>';
	}
	return sv;
};



var showback=function(config) { // pass either 'false' (to hide) or a function to be run from the back button (or null)
	var bb=document.getElementById('backbutton');
	if(bb) {
		var hide=(config!==false);

		changeclass(bb,'hidden',hide);
		if(config) {

			taketaps(bb,'click',config);
		} else {
			taketaps(bb,'click',nav.back);
		}
	}
};

var showhome=function(tf) {
	if(tf===false) {
		changeclass(panel.home,'hidden');
		cleartaps(panel.home,'click',nav.home);
	} else {
		changeclass(panel.home,'hidden',true);
		taketaps(panel.home,'click',nav.home);
	}
};

var nav={
	history:[],
	last:'',
	lastlist:'',
	current:'',
	splash:function() {
		panel.fullscreen();
		panel.setpanel(panel.content,'splash');
		// show logos
		soundtrack.play('sting');
		setTimeout(function() {
			changeclass(document.getElementById('logos'),'bg-space');
			changeclass(document.getElementById('logos'),'fadein');
			document.getElementById('logoimage').src='img/plumlanding_logo.png';
			document.getElementById('logoimage').alt='Plum Landing';
			setTimeout(nav.intro,2000);
		},2000);
	},
	intro:function() {
		panel.fullscreen();		
		panel.setpanel(panel.content,'intro');
		introanimation.load();
	},
	home:function() {
		changeclass(document.getElementById('startup'),'hidden');
		this.go('home');
	},
	list:function(type) {
		this.go('list',type);
	},
	cards:function() {
		this.go('cards');
	},
	single:function(id) {
		this.go('single',id);
	},
	parents:function() {
		nav.go('parents');
	},
	gallery:function(id,date) {
		nav.go('gallery',{id:id,date:date});
	},
	completedlist:function() {
		this.list('completed');
	},
	done:function(id) {
	// don't add it to the 'back' history, just record it
		this.go('done',id);
		
	},
	back:function() {
		var to;
		if(this.current[0]=='pick') {

			// special case when going back from a picked card, depending on where we came from before that. Either it goes back to the list, or back to the carousel
			to=this.history.pop();

			switch(to[0]) {
				case 'single':
				to=this.history.pop();
				this.go(to[0],to[1]);
				this.history.pop();
				break;
				
				case 'cards':
				this.cards();
				this.history.pop();
				break;
			}
			
		} else {

			to=this.history.pop();
			if(to) {
				this.go(to[0],to[1]);
				this.history.pop();
			}
		}
	},
	
	go:function(where,options) {
		animation.stop();
		this.from=this.current;
		this.history.push(this.from);
		listview.anchorid=null;
		this.left(this.from[0],this.from[1]);
		var tp=this.pagetype(where,options);
		if(tp) track('pageview',tp);
		switch(where) {
		
		
			case 'home':
				panel.fullscreen();
				panel.setpanel(panel.content,'index');
				index.activate();
			break;
			
			case 'list':
				panel.showtopnav();
				showback();
				panel.showlist();
				listview.type='mech';
				listview.listid='list';
				if(options) {
					listview.type=options; // could be 'open';
				}
				panel.setpanel(panel.content,'list');
				listview.activate();
				this.lastlist=this.pagetype(where,options);
				showhome();
			break;
			
			case 'gallery':
				listview.listid='glist';
				panel.showtopnav();
				if(options) {
					app.mission=options.id;
					listview.galleryid=options.id;
					if(options.date) {
						listview.anchorid=options.date;
					}
				}
				panel.showlist();
				panel.setpanel(panel.content,'gallery');
				showback();
				showhome();
			break;
			
			case 'cards':	
				panel.shownav();
				cards.showcards();
				this.lastlist=this.pagetype(where,options);
				showhome();	
			break;
			
			case 'single':
					var id=(options)?options:app.mission;
					app.mission=id;
					panel.shownav();
					cards.singlecard(id);
					showback(); // sometimes you get here from the home screen
					showhome();	
			break;
			
			case 'pick':
				tools.showtool();
			break;
			
			case 'done':
				tools.showtool(true);	
				panel.fullscreen();
				panel.setpanel(panel.content,'completed');
				showback(false);
			break;
			
			case 'stat':

			if(options) {
				panel.showtopnav();
				panel.showlist();
				panel.setpanel(panel.content,'stats');
				var lid=document.getElementById(this.listid);

				if(lid) {
					var output='';
					for(var opt in options) {
						output+=options[opt] + "\n";
					}
				
					output+='<button id="clear">CLEAR DATA</button>';
					lid.innerHTML=output;
					
					var clearbtn=document.getElementById('clear');
					taketaps(clearbtn,'click',user.cleardata);
				}
				showback();
				
				showhome();
			}
			break;
			
			case 'parents':
				window.removeEventListener('loaded',listview.parentsready);
				window.addEventListener('loaded',listview.parentsready);	
				changeclass(document.getElementById('startup'),'hidden');
				panel.showlist();
				panel.showtopnav();
				panel.setpanel(panel.content,'parents');
				panel.setpanel(panel.bottomnav,'top');
				panel.showpanel(panel.bottomnav);
				showback(false);
				showhome();
				scrollshift=templates.parents.scrollshift;
			break;
		}



		var n=where;
		if(options) {n=[where,options];}
		
		user.dailycredit('any',true);
		logdata.nav(n);
		this.current=[where,options];
	},
	left:function(where,options) {
		// clean up whatever we left from]
		if(where==='cards') {	
			cards.leavecards();
		}
		if(where==='pick') {
			tools.showtool(true);
		}
	},
	pagetype:function(where,options) {
		// page name for analytics
		switch (where) {
			case 'parents':
				return "Info";

			
			case 'home':
				return "Home";

			
			case 'gallery':
				return "Gallery " + options.id;

			
			case 'cards':
				return "Todays Missions";

			
			case 'list':
			// 'open','completed','all'
				if(options==='open') return "Missions in Progress";
				if(options==='completed') return "Our Progress";
				return "All Missions List";

			
			case 'single':
				return "Mission View " + options;

			
			case 'pick':
				return "Mission Open " + options;

			
			case 'done':
				return "Mission Complete " + options;

		}
		return null;
	},
	clicktop:function() {
		pastscroll(false);
	},
	init:function() {
		this.go=this.go.bind(this);
		this.back=this.back.bind(this);
		this.list=this.list.bind(this);
		this.home=this.home.bind(this);
		this.cards=this.cards.bind(this);
		this.single=this.single.bind(this);
	}
};
nav.init();


index.init();

/* ACTIVITY LIST */

var scrollobj={};

var listview={
	type:'all',
	scrollpos:{},
	open:[],
	completed:[],
	seen:[],
	listed:[],
	listid:'list',
	searchbox:null,
	suggest:null,
	
	activitylist:function() {

		
		var html="";
		var title="";
		var listsource;
		this.listed=[];
		this.twiddles=[];
		if(this.type==='open') {
			if(user.missionstatus.open.length > 0) {


			this.progresslistready(user.missionstatus.open);
			scrollshift=templates.list.scrollshift.progress;
			}
		} else if(this.type==='completed') {
			logdata.readalllogs('closefile',this.completedlistready);
			scrollshift=templates.list.scrollshift.complete;
		} else {
		// all missions
			title=templates.list.alltitle;
			html+=title;
			// sort by mechanic
			var listset={};
			
			scrollshift=templates.list.scrollshift.all;
			
			scrollshift=fontfactor*-4 - (app.width*.3)*146/182; // plum is 182x146, 30% app width
			
			// pick from the ones given out today
			var faveset=[];
			for(var a in missionstouse) {
				var id=missionstouse[a];
				
				var tool=activitydata[id].tool;
				if(!listset[tool]) listset[tool]=[];
				listset[tool].push(id);
				
				if(user.loaddata(id,'fave')) {
					faveset.push(id);
				}
			}
	
			var addsticky=(nosticky)?"":" sticky";
	
			for(var n in tools.order) {
				var t=tools.order[n];
				if(!listset[t]) continue;
				this.twiddles.push(t);
				html+="<div id=\"twiddle_"+t+"\" class=\"twiddler vcenter "+addsticky+"\" style=\"z-index:1;\"><img src=\"img/all_missions_"+t+".svg\" alt=\""+tools.names[t]+"\" class=\"tw_icon\" /><h2>" + tools.names[t]+"</h2><div class=\"tw_chevron tw_" + t + " down\"></div></div>";
				html+="<div id=\"sublist_"+t+"\" class=\"sublist\">" + this.makelist(listset[t],null,{lined:true}) + "</div>";
			}
			
			// now favorites
			if(faveset.length > 0) {
				t="fave";
				this.twiddles.push(t);
				html+="<div id=\"twiddle_"+t+"\" class=\"twiddler vcenter"+addsticky+"\" style=\"z-index:1;\"><img src=\"img/all_missions_"+t+".svg\" alt=\"favorites\" class=\"tw_icon\" /><h2>Favorites</h2><div class=\"tw_chevron tw_" + t + "  down\"></div></div>";
				html+="<div id=\"sublist_"+t+"\" class=\"sublist\">" + this.makelist(faveset,null,{lined:true}) + "</div>";
			}
		}

		return html;
	},
	
	progresslistready:function(dataobj,editing) {
			var html='';
			var title=templates.list.progresstitle;
			if(dataobj.length < 1) {nav.home(); return;}
			var d=logdata.groupbydate(dataobj);
			

			html+=title;
			for(var li in d) {
				html+=this.makedateheader(d[li].date,d[li].dateid);
				var listset=d[li].acts;
				html+=this.makelist(listset);
			}

		var me=this;
		if(!document.getElementById('list')) {
			setTimeout(function() {me.progresslistcontent(html);},50); // if it returns the data too quickly, before the list HTML is ready (on desktop)
		} else {
			me.progresslistcontent(html);
		}
		this.editing=editing;
		panel.setpanel(panel.bottomnav,'edit');
		panel.showpanel(panel.bottomnav); // so this list needs to be shortened by the height of the bottomnav
		
	},
	
	completedlistready:function(dataobj) { // data obj is an array 
			dataobj.reverse();
			user.savedata('overall', 'clickedprogress',true);
			var html='';
			var title=templates.parse(templates.list.completedtitle);

			var d=logdata.groupbydate(dataobj);

			html+=title;
			for(var li in d) {
				html+=this.makedateheader(d[li].date,d[li].dateid);
				var listset=d[li].acts;
				html+=this.makelist(listset,null,{'nostatus':true,'c':true});
			}

		var me=this;
		if(!document.getElementById(this.listid)) {
			setTimeout(function() {me.setlistcontent(html);},50); // if it returns the data too quickly, before the list HTML is ready (on desktop)
		} else {
			me.setlistcontent(html);
		}
	},
	

	gallerylistready:function(dataobj) {
		var html="";
		html+=templates.parse(templates.gallery.scrolltitle);

		scrollshift=templates.gallery.scrollshift;
		headersize=topmargin;//templates.gallery.headersize;


		dataobj.reverse();
		
		var d=logdata.groupbydate(dataobj);

		for (var l in d) {
		// 'results' is a list of images.
			
			html+=this.makedateheader(d[l].date,d[l].dateid);
			var listset=d[l].acts;
			
			html+="<div class=\"gallerypix\">";
			for(var s in listset) {
				var r=listset[s].result;
				var id=listset[s].id;
				if(!r) continue;
				if(r.hasOwnProperty('photos')) {

				for(var p in r.photos) {
					var src=io.getURL(r.photos[p]);
					if(!app.ondevice) {
						src="../test/testimages/" + r.photos[p];
					}
					html+="<img src=\""+src+"\" class=\"galleryimage\" alt=\"Photo "+(p+1)+"\">";
				}
			}
			
				if(r.hasOwnProperty('count')) {
					html+="<p>Counted "+r.count+" " + tools.counter.itemname(id,r.count)+"</p>";
				}
			}
			html+="</div>";
		}
		var me=this;
		if(!document.getElementById('glist')) {

			setTimeout(function() {me.setlistcontent(html,'glist');},50); // if it returns the data too quickly, before the list HTML is ready (on desktop)
		} else {
			me.setlistcontent(html,'glist');
		}
	},
	gallerylist:function() {		
		this.listed=[];
		this.twiddles=[];
		user.getmissionresults(this.galleryid,this.gallerylistready);
		return "";
	},
	
	parentsready:function() {
		this.setscrolling('parentscroll');
		// set all of the anchor tags to open in system browser

		var externalclick=function(ev) {
			cordova.InAppBrowser.open(ev.target.href, '_system', 'location=yes');return false;
		};
		var browserclick=function(ev) {
					window.open(ev.target.href,'_new');return false;
			};

			var el=document.querySelectorAll('a.link');
			for(var e=0;e<el.length;e++) {
				if(app.ondevice) {
					el[e].onclick=externalclick;
				} else {
					el[e].onclick=browserclick;
				}
			}
	},

	progresslistcontent:function(html) {
		var lst=document.getElementById('list');
		changeclass(lst,"withbottom");
		this.setlistcontent(html);
		if(this.editing) {
			this.setupedit();
		} else {
			document.getElementById('btn-edit').innerHTML="Edit";
		}

	},

	editmode:function() {
		if(!this.editing) {
			this.editing=true;
			this.setupedit();
		} else {
			this.editing=false;
			document.getElementById('btn-edit').innerHTML="Edit";
			this.progresslistready(user.missionstatus.open);
		}
	},
	
	setupedit:function() {
		var delbuttons=document.querySelectorAll('li.missionline');
		document.getElementById('btn-edit').innerHTML="Done";
		for(var i=0;i<delbuttons.length;i++) {
				var delbutton=delbuttons[i];
				var id=delbutton.getAttribute('data-mid');
				changeclass(document.getElementById('status_'+id),'hidden');
				var actiondiv=document.createElement('div');
				changeclass(actiondiv,'listaction');
				var redx=document.createElement('a');
				redx.innerHTML='<img src="img/red_x.svg" class="redx actionicon" />';
				redx.setAttribute('data-mid',id);
				changeclass(redx,'remove');
				changeclass(redx,'listbug');
				actiondiv.appendChild(redx);
				delbutton.appendChild(actiondiv);
				taketaps(redx,'click',this.removemission);
			}
	},
	
	removemission:function(ev) {
		var id=ev.currentTarget.getAttribute('data-mid');
		user.abortmission(id);
		this.progresslistready(user.missionstatus.open,true);
	},
	
	makedateheader:function(date,dateid) {
		var id="";
		if(dateid) {
			id='id="'+dateid+'"';
		}
		return "<div class=\"dateheader\" "+id+">"+date+"</div>";
	},
	
	setlistcontent:function(content,listid) {
		if(!listid) {listid='list';}
		this.listid=listid;
		var l=document.getElementById(listid);
		l.innerHTML=content;
		this.activate();
		if(document.getElementById("galleryname")) {
			document.getElementById("galleryname").innerHTML=templates.parse(templates.gallery.title);
		}
	},
	
	makelist:function(arr,titlein,special) {
		if(arr.length==0) return "";
	
		var lined="";

		if(!special) special={};
		if(special.lined) {
			lined=" lined";
		}
		var title=titlein;
		var html="<ul class=\"act" + lined + "\">";
		var uniques={};
		var idu;
		for(var a in arr) { // this is an array of ids
			var id;
			if(arr[a].id) {
				id=arr[a].id;
			} else {
				id=arr[a];
			}
			idu=id;
			if(uniques[idu]) {
				// need a new actual ID for this...
				var inc=1;
				while(uniques[idu]) {
					idu=id+"_" + inc;
					inc++;
				}
			}
			
			uniques[idu]=true;
			if(!special.nostatus) {
				this.listed.push(idu);
			}

			title=activitydata[id].title;
			var status=user.showstatus(id);
						
			var button="";

			if(special.nostatus) {
				if(special.c) {// this is the completed list, so only thing to show would be the gallery icon for photos
					
					var t=activitydata[id].tool;
					
					switch (t) {
						case "camera":		
						var date=logdate(new Date(arr[a].done),'day');

						if(arr[a].result && arr[a].result.photos.length > 0) {
						button='</div><div class="listaction"><a class="listbug showresults" data-mid="'+ id +'" data-date="'+date+'"><img src="img/icon_feed_gallery.svg" class="actionicon" alt="gallery" /></a>';
						}
						this.listed.push(idu);
						break;
					
						case "scavenger":
						this.listed.push(idu);
						break;
						
						case "counter":
						this.listed.push(idu);
						break;
					
					}
					
					if(arr[a].badge) {
						var badgeline="<li class=\"badgeline\"><div class=\"vctr inlistbadge "+badges.bg(arr[a].badge)+"\"><div class=\"inlinebadge\"><img class=\"inlinebadgeimg\" src=\"" + badges.heximagesrc(arr[a].badge) +"\" width=\"55\" height=\"63\"></div><span class=\"badgename\">"+arr[a].badge.name+"</span></div></li>";
						
						html+=badgeline;
					}
					
				}
			
			} else if(status==user.status.open) {

				button="<div id=\"status_"+id+"\" class=\"liststatus listprogress\">IN PROGRESS</div>";
			} else if(status==user.status.done) {
				

				var timesdone=user.loaddata(id,'closed');

				button="<div class=\"liststatus listcomplete\"><img class=\"checkoff\" src=\"img/checkmark.svg\" alt=\"\" width=\"11\" height=\"11\" /> "+timesdone+" </div>";
			} else if(newmissions[id]===true) {
				button="<div class=\"liststatus listnew\">New</div>"
			}
			
			var img=id + "_th.jpg";
			

			html+="<li class=\"missionline\" data-mid=\""+id+"\"><div class=\"missionselect\" data-mid=\""+id+"\"><img id=\"thumb_" + idu+"\" src=\"img/act/"+img+"\" width=\"50\" height=\"28\" alt=\""+title+"\" class=\"listimage\"/><div class=\"label\"><span class=\"title\">" + title + "</span></div>" +button+"</div></li>";
		}
		html+="</ul>";
		return html;
	},
	putimage:function(id,src) {

		var thumbimg=document.getElementById('thumb_' + id);
		thumbimg.src=src;
	},
	
	activatebuttons:function() {
		var i,id;
		
		
			var missionbuttons=document.querySelectorAll('div.missionselect');
			for(i=0;i<missionbuttons.length;i++) {
				var missionbutton=missionbuttons[i];
				taketaps(missionbutton,'click',this.choose);
			}
			
		
		for(i in this.twiddles) {
			id=this.twiddles[i];
			var twiddler=document.getElementById('twiddle_'+id);
			if(twiddler) {
				twiddler.setAttribute('data-twid',id);
				taketaps(twiddler,'click',this.twiddle);
			}
		}

			var resbuttons=document.querySelectorAll('a.showresults');
			for(var e=0;e<resbuttons.length;e++) {
				var resultbutton=resbuttons[e];
				taketaps(resultbutton,'click',this.showresults);
			}

		if(nosticky) {			
			var hdr=document.getElementById('headers');
			if(hdr) {
				hdr.setAttribute('data-twid',"");
				taketaps(hdr,'click',this.twiddle);
			}
		}
	},
	
	activate:function() {
	
		taketaps(panel.home,'click',nav.home);
		this.activatebuttons();

		

		this.setscrolling(this.listid);
		
		scrollobj.l.removeEventListener('scroll', this.settwiddles);
		scrollobj.l.addEventListener('scroll', this.settwiddles);
		
		checkscroll();
	},
	
	setscrolling:function(listid) {
		topmargin=Math.max(40,fontfactor*app.width/100); // WARNING MAGIC NUMBERS - CHECK CSS 
		
		scrollobj.t=document.getElementById('listtitle');
		scrollobj.c=document.getElementById('content');
		
		scrollobj.l=document.getElementById(listid);
		scrollobj.l.scrollTop=this.scrollpos[this.type];
	
		scrollobj.l.removeEventListener('scroll', inscroll);
		scrollobj.l.addEventListener('scroll', inscroll);
		
		if(this.anchorid) {
			var a=document.getElementById(this.anchorid);
			if(a) {			
				scrollobj.l.scrollTop=a.offsetTop-topmargin-headersize;
			}
		}
	},
	
	twiddle:function(ev) {
		var tname=ev.target.getAttribute('data-twid');
		if(!tname) return;
		var sublist=document.getElementById('sublist_' + tname);
		
		if(!hasclass(sublist,'short')) {
			// This is closing - find the top
			var listbox=sublist.getBoundingClientRect();
			if(listbox.top<0) {
				new tween().start(scrollobj.l,'scrollTop',scrollobj.l.scrollTop,scrollobj.l.scrollTop+listbox.top - (3*topmargin),250);
			}
		}
		toggleclass(sublist,'short');
		var chevrons=document.querySelectorAll('.tw_' + tname);
			for(var ch=0;ch<chevrons.length;ch++) {
				var chevron=chevrons[ch];
				toggleclass(chevron,'down');
			}
		// have to scroll if closing something off screen to the top - should scroll so that the TOP of the thing closed is still on screen.
	},
	
	fixtwiddles:function() {
		this.settwiddles();
	},
	
	settwiddles:function() {
		var nomore=false;
		var hdr=document.getElementById('headers');
		var lasttwiddleup=null;
		for(var t in this.twiddles) {
			var id=this.twiddles[t];
			var d=document.getElementById('sublist_' + id);
			var tw=document.getElementById('twiddle_' + id);
			var l=null;
			
			if(nomore || hasclass(d,'short') || (l=tw.getBoundingClientRect().top) > topmargin) {
// put this twiddle in position		
				if(l) nomore=true;
			} else {
			// move this twiddle to the top
				lasttwiddleup=id;
			}
		}
		if(nosticky && lasttwiddleup) {
			changeclass(hdr,'hidden',true);
		if(hdr.getAttribute('data-twid')!=lasttwiddleup) {
			tw=document.getElementById('twiddle_' + lasttwiddleup);
			hdr.innerHTML=tw.innerHTML;
			hdr.setAttribute('data-twid',lasttwiddleup);
		}
		} else {
			changeclass(hdr,'hidden');
		}

	},
	
	
	choose:function(ev) {
	
		scrollobj.l=document.getElementById(this.listid);
		this.scrollpos[this.type]=scrollobj.l.scrollTop;
		
		var id=ev.currentTarget.getAttribute("data-mid");
		
		this.teardown();

		nav.single(id);
		if(this.type=="open") {
			cards.backdo=3;
		} else {
			cards.backdo=2;
		}
	},
	
	showresults:function(ev) {
		scrollobj.l=document.getElementById(this.listid);
		this.scrollpos[this.type]=scrollobj.l.scrollTop;
		var id=ev.currentTarget.getAttribute("data-mid");
		var d=ev.currentTarget.getAttribute("data-date");
		nav.gallery(id,d);
	},
	
	init:function() {
		this.activitylist=this.activitylist.bind(this);
		this.gallerylist=this.gallerylist.bind(this);
		this.choose=this.choose.bind(this);
		this.showresults=this.showresults.bind(this);
		this.settwiddles=this.settwiddles.bind(this);
		this.fixtwiddles=this.fixtwiddles.bind(this);
		this.twiddle=this.twiddle.bind(this);
		
		this.removemission=this.removemission.bind(this);
		this.editmode=this.editmode.bind(this);
		
		this.parentsready=this.parentsready.bind(this);
		
		this.progresslistready=this.progresslistready.bind(this);
			this.completedlistready=this.completedlistready.bind(this);
			
			this.gallerylistready=this.gallerylistready.bind(this);
		
	},
	teardown:function() {
		var i,b;
		cleartaps(panel.home,'click',nav.home);
		
		for(i in this.listed) {
			var id=this.listed[i];
			b=document.getElementById('b_'+id);
			if(b) {
				cleartaps(b,'click',this.choose);
			}
		}
	}

};

listview.init();


/* ACTIVITY CARD FUNCTIONS */

var cards={

	cardids:[], // the set of cards chosen from the full deck
	carddots:[], // the little dots showing which card you're on
	handsize:0,
	lastcard:0,
	cardnum:0,
	dailylist:0,
	backdo:1, // what to do when "back" is clicked
	
	cardwidth:86,
	cardoffset:7,
	
	setdots:function() {
		var dotset=document.getElementById('carddots');
		dotset.innerHTML="";
		var d;
		for(d=1;d<=this.handsize;d++) {			
			var dv=document.createElement('div');
			dv.id="d"+d;
			dv.className="carddot";
			dotset.appendChild(dv);
		}

		this.carddots=[];
		
		for(d=0;d<this.handsize;d++) {
			var j=d+1;
			this.carddots[d]=document.getElementById('d' + j);
			this.setbutton(this.cardids[d],true,this.choosecard);
		}
		
		this.backdo=1;
		
	},
	
	newcarousel:function() {// new carousel after cards have been opened - reset positions
		cards.cardnum=0;
	},
	
	showcards:function(whatcard) {
		this.norepeat=-1;
		var lastc=user.whichdailies(lists.length);

		if(lastc!=this.dailylist) {
			this.drawcards(lastc);
		}

		user.savedata('overall', 'clickedtoday',true);
		// set up the first card, prepare the others. Show the arrows to go back and forth.
		
		var cardholder='<div id=\"allcards\" class=\"cardset transit\">';


		for(var a in this.cardids) {
			var id=this.cardids[a];
			var card=this.makecard(id);
			cardholder+=card;
		}
		
		
		cardholder+="</div>";
		
		panel.content.dom.innerHTML=cardholder;
		panel.content.active='cards';
		
		this.cardset=document.getElementById('allcards');
	

		this.startleft=0;
		this.startdrag=0;
		this.diff=0;
		this.cardid=0;

		panel.setpanel(panel.bottomnav,'carousel');

		changeclass(panel.content.dom,'daily');
		this.setdots();
		
		whatcard=whatcard?whatcard:this.cardnum;
		
		this.setcard(whatcard);
		
		showback();
	},
	
	drawcards:function(set) {
		// choose the 5(?) cards that will be displayed
		this.cardids=[];


	
		this.dailylist=set;
		var cardlist=lists[this.dailylist];
		
		this.handsize=cardlist.length;
		for(var id in cardlist) {
			var mu=cardlist[id];
			if(mu.indexOf("/") > -1) {
				mu=this.pickwhich(mu);
			}
			this.cardids.push(mu);
		}
		this.lastcard=this.handsize-1;
	},

	pickwhich:function(str) { // check the date and if it's winter, use the first; spring use the second.
		var season=str.split('/');
		var m=thismonth();
		if(m > 2 && m <10) {
			return season[1];
		} else {
			return season[0];
		}
	},

	makecard:function(id) {
		if(id=='id') id=app.mission;
		// make a card (DOM element? string?) out of an activity
		
		var activity=activitydata[id];


		var img=id +".jpg";


		var cd='<div class="actcard" id="'+id+'"><div class="holdactimage" id="hold_' + id + '"><img class="actimage" src="img/act/' + img+ '" id="hero_'+id+'" alt="'+activity.title+'"  />';
		if(newmissions[id]===true) {
			cd+="<div class=\"newactivity\">New</div>";
		}
		cd+="</div>";


		var lastid=app.mission;
		
		app.mission=id;
		cd=cd + templates.parse(templates.cardbody.html,templates.cardbody.subs);
		
		app.mission=lastid;
		
		return cd;
	},
	putimage:function(id,src) {
		var i=document.getElementById('hero_' + id);
		i.src=src;
	},
	goback:function() {

		switch(this.backdo) {
			case 1: // back to the carousel
				panel.setpanel(panel.bottomnav,'carousel');
				// may need to reset the current card		
				
				if(this.cardset) {changeclass(this.cardset,'chosen',true);}
				this.setcard(this.cardnum);
			break;
			
			case 2:
			// go back to the full list
			nav.list('mech');
			break;
			
			case 3:
			// go back to the short list
			nav.list('open');
			break;
		
		}
	},
	nextcard:function() {
		this.showcard(this.cardids[this.cardnum],true); // return current card to detente
		this.setcard(this.cardnum+1);
	},
	
	prevcard:function() {
		this.showcard(this.cardids[this.cardnum],true); // return current card to detente
		this.setcard(this.cardnum-1);
	},
	
	setcard:function(newcard) {
		if(newcard<0) {this.cardnum=0;}
		else if(newcard>this.lastcard) this.cardnum=this.lastcard;
		else this.cardnum=newcard;
		
		this.positioncard();
		
		if(this.norepeat==this.cardnum) return;
		
		this.norepeat=this.cardnum;

		this.countcard();

		changeclass(panel.bottomnav.ui.arrowleft,'disabled',this.cardnum>0);
		changeclass(panel.bottomnav.ui.arrowright,'disabled',this.cardnum<this.lastcard);
	
		for(var c=0;c<this.handsize;c++) {
			changeclass(this.carddots[c],'select',c!=this.cardnum);
		}
		this.cardid=this.cardids[this.cardnum];
		
		
	},
	
	positioncard:function() {
		this.cardset.style.left=((this.cardoffset+this.cardnum * -this.cardwidth)) + "%";
		changeclass(this.cardset,'transit');
		
	},
	countcard:function() {
		this.showcard(this.cardids[this.cardnum],true);
		user.seemission(this.cardids[this.cardnum]);
		track("pageview","Carousel "+ this.cardids[this.cardnum]);
	},
	
	choosecard:function(ev) {
		cleartaps(panel.content.dom,'move',this.dodrag);
		cleartaps(panel.content.dom,'down',this.dragcard);
		cleartaps(panel.content.dom,'up',this.leggo); // stop the move/drag bit


		app.mission=this.cardid;

		// when choosing a card, hero image goes away and more information appears. Also the tool panel appears.

		// get the image child of this card and shrink it
		
		panel.setpanel(panel.bottomnav,'activity');
		this.showcard(this.cardid);
		
		
		
		if(this.cardset) {
			this.cardset.style.left=parseInt(this.cardset.style.left)-this.cardoffset + "%";
			changeclass(this.cardset,'chosen');
		}
		
		// make the app aware of which card is chosen
		
		user.openmission(app.mission);

		this.checkcompletion(user.iscompletable(app.mission));		
		// save that the user has chosen this


		nav.go('pick',app.mission);
		
	},
	
	favethis:function(ev) {
		var id=ev.target.getAttribute("data-mid");
		var ic=ev.target.childNodes[0];
		ic.src=(user.togglefave(id))?"img/heart_full.svg":"img/heart_open.svg";
	},
	
	setbutton:function(cardid,hide,tapfunction) {
		var startbutton=document.getElementById('start_' + cardid);
		var resbutton=document.getElementById('results_' + cardid);

		var resbuttons=document.querySelectorAll('div.favoriteicon');
			for(var e=0;e<resbuttons.length;e++) {
				var favebtn=resbuttons[e];
				taketaps(favebtn,'click',this.favethis);
			}


		changeclass(resbutton,'hidden');
		changeclass(startbutton,'share',true);
		if(hide===false) {
			changeclass(startbutton,'hidden');
			return;
		}
		var st=user.showstatus(cardid);
		

			if(st==user.status.done) {
				startbutton.innerHTML="Do it again!";
				changeclass(startbutton,'bg-green');
				if(activitydata[cardid].tool=='camera' && user.loaddata(cardid,'hasgallery')) {
					changeclass(startbutton,'share');
					changeclass(resbutton,'hidden',true);
					taketaps(resbutton,'click',this.seeresults);
				}	
			} else if(st==user.status.open) {
				changeclass(startbutton,'bg-green',true);
				startbutton.innerHTML="Finish this!";
				// cover the image with main purple 70% opacity
				var actimage=document.getElementById('hold_'+cardid);
				var scrim=document.createElement('div');
				scrim.className="progscrim";
				scrim.innerHTML="<span class=\"text\">Mission in Progress</span>";
				actimage.appendChild(scrim);
			} else {
				changeclass(startbutton,'bg-green',true);
				startbutton.innerHTML="Do it!";
			}
			if(tapfunction) {
				taketaps(startbutton,'click',tapfunction);
			}
			changeclass(startbutton,'hidden',true);
	},
	
	seeresults:function(ev) {
		var id=ev.currentTarget.getAttribute("data-mid");
		nav.gallery(id);
	},
	
	showcard:function(cardid,orhide) {

		var heroholder=document.getElementById('hold_' + cardid);
		changeclass(heroholder,'flat',orhide);
		
		changeclass(panel.content.dom,'tool',orhide);

		
		var carddom=document.getElementById(cardid);
		var desc=document.getElementById(cardid + "_desc");
		if(orhide) {
			desc.innerHTML=this.shortdescription(cardid);
			changeclass(carddom,'big',true); // don't need to run setbutton here b/c will be called from setdots()
			taketaps(panel.content.dom,'down',this.dragcard);
		} else {
			panel.shownav();
			changeclass(carddom,'big');
			this.setbutton(cardid,false);
			desc.innerHTML=this.fulldescription(cardid);	
		}
		tools.showtool(orhide);
	},
	
	fulldescription:function(id) {
		changeclass(document.getElementById('fade_'+id),'hidden',true);
		return "<p>" + activitydata[id].full + "</p><p><span class=\"acttip\">Tip:</span> " + activitydata[id].tip + "</p>";	
	},
	
	shortdescription:function(id) {
		return "<p class=\"shortdesc\">" + activitydata[id].desc + "</p>";
	},
	
	singlecard:function(id) {

		panel.showtopnav();
		app.mission=id;
		this.cardid=id;

	

			panel.setpanel(panel.content,'singlecard');
			panel.setpanel(panel.bottomnav,'blank');
			showback();
			
			this.setbutton(id,true,this.choosecard);
			
			// hide the "complete"
			var co=document.getElementById('complete');
			changeclass(co,'hidden');
			var thiscard=document.getElementById(id);
			changeclass(thiscard,'nocarousel');
			tools.showtool(true);
			
			
			changeclass(document.getElementById('fade_'+id),'hidden');
			this.checkcompletion(user.iscompletable(app.mission));

	},
	
	opencard:function(id) {
		this.leggo();
		app.mission=id;
		
		var onecard="<div class=\"fullcard\">"+ this.makecard(id) + "</div>";
		panel.shownav();
		

		panel.content.active='cards';
		panel.content.dom.innerHTML=onecard;
		
		panel.setpanel(panel.bottomnav,'activity');
		tools.showtool();
		
		changeclass(document.getElementById('start_'+id),'hidden');
		changeclass(document.getElementById(id),'big');


		var desc=document.getElementById(id + "_desc");
		desc.innerHTML=this.fulldescription(id);
		
		
		var heroholder=document.getElementById('hold_'+id);
		changeclass(heroholder,'flat');
		
		
		var co=document.getElementById('complete');
		changeclass(co,'hidden',true);
			
		this.checkcompletion(user.iscompletable(app.mission));			
	},
	
	donefornow:function() {
		
		track('event',{category:"Mission Done For Now",action:app.mission});
		nav.back();
	},
	
	done:function() {
		// flip the card? somewhat tricky because dimensions need to be specified
		var card=document.getElementById(app.mission);
		changeclass(card,'cardcomplete');

		nav.done(app.mission);

		user.completemission(app.mission);
		
	},

	rate:function(rating) {

		user.savedata(app.mission,'rating',rating);
		nav.home();
	},
	
	
	checkcompletion:function(percentage) {
		// check to see whether the current state is completable
		var tf=percentage>0;
		var co=document.getElementById('btn-complete');

		changeclass(co,'disabled',tf);
		if(tf) {
			taketaps(co,'click',cards.done);
		}else {
			cleartaps(co,'click',cards.done);
		}
		return tf;
	},
	
	fullcamera:function(isfilled) {

		var cl=document.getElementById('btn-close');


		changeclass(cl,'disabled',!isfilled);

		if(isfilled) {
			cleartaps(cl,'click',cards.donefornow);
		} else {
			taketaps(cl,'click',cards.donefornow);
		}

	},
	
	
	dragcard:function(ev) {

		panel.setpanel(panel.bottomnav,'carousel');
		this.startdrag=app.getcoords(ev,true).x;
		this.diff=0;
		this.startleft=this.cardset.style.left ? parseInt(this.cardset.style.left):0;


		taketaps(panel.content.dom,'move',this.dodrag);
		taketaps(panel.content.dom,'up',this.leggo);
		
		changeclass(this.cardset,'transit',true);
	},
	
	dodrag:function(ev) {

		this.diff=app.getcoords(ev,true).x-this.startdrag;

		this.cardset.style.left=(this.startleft + this.diff*app.pixelratio) + "%";
	},
	
	leggo:function(ev) {

		cleartaps(panel.content.dom,'move',this.dodrag);
		cleartaps(panel.content.dom,'up',this.leggo);
		
		// snap card to nearest
		
		// if moved more than 1/2 toward the next one, should move it over

		var dir=this.diff>0?1:-1;

		var move=this.cardwidth/2-(dir*30);
		var nleft=parseInt((parseInt(this.cardset.style.left)-(move))/(this.cardwidth*-1));
		this.setcard(nleft);
		},
		
		
	init:function() {
		// for swiping
		this.dragcard=this.dragcard.bind(this);
		this.dodrag=this.dodrag.bind(this);
		this.leggo=this.leggo.bind(this);

		// back button		
		this.goback=this.goback.bind(this);
		
		this.setdots=this.setdots.bind(this);
		
		// previous/next
		this.prevcard=this.prevcard.bind(this);
		this.nextcard=this.nextcard.bind(this);
		
		// chosen
		this.choosecard=this.choosecard.bind(this);
		
		this.makecard=this.makecard.bind(this);
		
		this.currentid=this.currentid.bind(this);
	},
	
	currentid:function() {
		return app.mission;
	},
	
	currentresults:function() {
		var blurb='<p class="followup">'+activitydata[app.mission].followup+'</p>';
		
		if(!tools[activitydata[app.mission].tool].results) return blurb;
		var ret='<p class="results">' + tools[activitydata[app.mission].tool].results(app.mission) + "</p>";
		return ret + blurb;
	},
	
	moveprogress:function(pdone) {
		var w2=parseInt(progresswidth*pdone);
		var ln=document.getElementById('fillline');
		ln.setAttribute('style','-webkit-transform: scaleX('+pdone+');transform: scaleX('+pdone+');'); // transform is better way for iOS 8
	},
	
	changeavatar:function(from,to) {
		document.getElementById('goodjob').innerHTML=user.levelup();
		var ok=document.getElementById('okay');
		changeclass(ok,'hidden');
		taketaps(ok,'click',nav.home);
		
		changeclass(document.getElementById('finishedblurb'),'hidden');
		
		
		// 1. remove the blurb
		// 2. change the background
		// 3. add the critters


		// add badge 1 and then badge 2
		var sw=document.getElementById('animlayer');
		
		changeclass(sw,'avswitch');
		sw.innerHTML="";
		
		var loadarray=[];		
		changeclass(document.getElementById('complete'),'bg-' + to.bg);

		if(from.id!="BEGIN") {
			document.getElementById('avatarname').innerHTML=from.name;
			loadarray=loadarray.concat(badges.badgespriteload(from));
			
		}
		
		loadarray=loadarray.concat(badges.badgespriteload(to));
		

		var me=this;

		animation.clear();
		animation.resize(app.width*2,app.height);
		sw.appendChild(animation.dom);
		if(loadarray.length > 0) {
			animation.load(loadarray, function() {me.playbadges(from,to);});
		} else {
			me.playbadges(from,to);
		}
	},
	
	
	playbadges:function(from,to) {

		if(from.id!="BEGIN") {
			var fromsprite=badges.badgesprite(from);
			fromsprite.position.x=fromsprite.position.x + app.width;
			animation.addsprite(fromsprite);
		}

		var tosprite=badges.badgesprite(to);
		animation.addsprite(tosprite);
	
		animation.animate();
		setTimeout(this.switchbadges,1500);
		
		setTimeout(function() {document.getElementById('avatarname').innerHTML=to.name;document.getElementById('avatarempty').src=badges.progressimagesrc(to);},2000);
	},
	
	switchbadges:function() {
		var sw=document.getElementById('animlayer');	
		changeclass(sw,'move');
		
		var ok=document.getElementById('okay');
		changeclass(ok,'hidden',true);
		
		
		soundtrack.play('levelup');
		changeclass(document.getElementById('cbg'),'fade');
	},
	
	leavecards:function() {

		tools.showtool(true);

		cleartaps(panel.content.dom,'down',this.dragcard);
		cleartaps(panel.content.dom,'move',this.dodrag);
		cleartaps(panel.content.dom,'up',this.leggo);
	}
};

var badges={
	heximagesrc:function(badgeobj) {
		return "img/badges/"+badgeobj.id+"_avatar.png";	
	},
	
	progressimagesrc:function(badgeobj) {
		return "img/badges/"+badgeobj.id+"_full.png";
	},
	
	silhouetteimagesrc:function(badgeobj) {
		return "img/badges/"+badgeobj.id+"_empty.png";
	},
	
	bg:function(badgeobj) {
		for(var i in config.badgelevels) {
			if(config.badgelevels[i].id==badgeobj.id) {
				return config.badgelevels[i].bg;
			}
		}
	},

	badgesprite:function(badgeobj) {
		var atlas="img/badges/"+badgeobj.id+"/" + badgeobj.id + "_atlas";
		var spriteconf={'only':atlas};
		if(badgeobj.multi) {
			spriteconf.prefix="img/badges/"+badgeobj.id+"/" + badgeobj.id + "_atlas";
		}
		
		var sheetset=animation.multiframes(spriteconf);
		
		var framesize=badgeobj.frame;
		
		// fit in 80% width and ~60% height
		var maxwidth=app.width*0.8;
		var maxheight=app.height*0.6;
		
		var maxyscale=maxheight/framesize.h;
		var maxxscale=maxwidth/framesize.w;

		
		var badgescale=Math.min(maxyscale,maxxscale);
		badgescale=badgescale*2; // already half-scale assets

		badgescale=Math.min(2,badgescale); // they don't look great over 2x
		
		
		var fullspriteconf={
			multiframes:sheetset,
			position:{x:app.width/2,y:app.height/2},
			scale:{x:badgescale,y:badgescale},
			looplength:badgeobj.looplength,
			frame:0,loop:-1
		};
		return fullspriteconf;
	},
	
	badgespriteload:function(badgeobj) {
		var sheet,loaditem;
		var loadarray=[];
		if(badgeobj.multi) {
				for(sheet=0;sheet<badgeobj.multi;sheet++) {
				loaditem="img/badges/"+badgeobj.id+"/"+badgeobj.id+"_atlas"+sheet+".json";
					if(!animation.alreadyloaded(loaditem)){ 
						loadarray.push(loaditem);
					}
				}
			} else {
				loaditem="img/badges/"+badgeobj.id+"/"+badgeobj.id+"_atlas.json";
				if(!animation.alreadyloaded(loaditem)){ 
					loadarray.push(loaditem);
				}
			}
		return loadarray;
	}

};

var tween=function() {
	this.starttime=0;
	this.dur=0;
	this.val=0;
	this.begin=0;
	this.end=0;
	this.range=0;
	this.prop=0;
	
	this.start=function(object,property,start,end,duration) {
		this.starttime=mydatenow();
		this.dur=duration;
		this.val=0;
		this.begin=start;
		this.end=end;
		this.range=end-start;
		this.object=object;
		this.property=property;
		this.tick=this.tick.bind(this);


		requestAnimationFrame(this.tick);
	};
	
	this.quad=function(t) {
	// quad in/out
	if ((t *= 2) < 1) {
				return 0.5 * t * t;
			}
			return - 0.5 * (--t * (t - 2) - 1);
	};
	
	this.tick=function() {
		var newnow=mydatenow();
		var perc=(newnow-this.starttime)/this.dur;
		this.val=this.begin + (this.range)*this.quad(perc);
		if(perc < 1) {
			requestAnimationFrame(this.tick);
		} else {
			this.val=this.end;
		}
		this.object[this.property]=this.val;
	};
};


cards.init();

/* TOOLS */

tools.init();

tools.camera.init();

tools.counter.init();

tools.scavenger.init();


var days=0; // start five days ago!
var dayclick=0;

function mydatenow() {
	if(!days) {
		days=0;
	}
	return new Date(Date.now() + days * 24*60*60*1000); // sometimes add a day!
}


var animation={
	stage:null,
	dom:null,
	renderer:null,
	sprite:null,
	play:false,
	last:0,
	ms:0,
	width:0,
	height:0,
	sprites:[],
	frame:0,

	init:function() {
		
		this.update=this.update.bind(this);
		this.loaded=this.loaded.bind(this);
		
		this.width=app.width;
		this.height=app.height;
		this.renderer=PIXI.autoDetectRenderer(this.width, this.height,{antialias: false, transparent: true, resolution: 1});
		this.dom=this.renderer.view;
		this.dom.id="animationview";
		this.stage=new PIXI.Container();
	},
	
	resize:function(w,h) {
		this.renderer.resize(w,h);
		this.width=w;
		this.height=h;
	},
	
	multiframes:function(options) {
		var sheetset={};
		var sheet="";
		for(var a=0;a<100;a++) {
			if(options.prefix) {
				sheet=options.prefix + a + ".json";
			} else {
				sheet=options.only + ".json";
				a=100;
			}
			if(PIXI.loader.resources[sheet]) {
				for(var tx in PIXI.loader.resources[sheet].textures) {
					sheetset[tx]=sheet;
				}
			} else {
				a=100;
			}
		}
		return sheetset;
	},
	
	alreadyloaded:function(spritesheet) {
		if(PIXI.loader.resources[spritesheet]) return true;
		return false;
	},
	
	load:function(spritesheets,loadcomplete) {

	this.onload=loadcomplete;
		PIXI.loader
	  .add(spritesheets)
	  .load(this.loaded);
	},

	loaded:function(ev) {
		// now everythings ready
			this.onload();
	},
	
	update:function(time) {
		var elapsed=time-this.last;
		this.last=time;

		this.ms+=elapsed;

		if(this.ms > 40) {
			this.ms=0;
			
			for(var sp in this.sprites) {
				var sprite=this.sprites[sp];
				if(sprite.stopped) continue;
				sprite.frame++;
				if(sprite.frame > sprite.looplength) {
					if(sprite.loop==-1 || sprite.looped < sprite.loop) {
						sprite.frame=1;
						sprite.looped++;
					} else {
						sprite.stopped=true;
						continue;
					}
				}
				var fr='frame'+sprite.frame+'.png';
				sprite.texture=PIXI.loader.resources[sprite.multiframes[fr]].textures[fr];


				}
			this.renderer.render(this.stage);
		}
		
		if(this.play) {
			requestAnimationFrame(this.update);
		}
	},
	
	addsprite:function(spritedef) {
		var sprite=new PIXI.Sprite(PIXI.loader.resources[spritedef.multiframes['frame1.png']].textures['frame1.png']);
		sprite.json=spritedef.json;
		sprite.frame=spritedef.frame;
		sprite.multiframes=spritedef.multiframes;
		sprite.looplength=spritedef.looplength;
		sprite.scale.x=spritedef.scale.x;
		sprite.scale.y=spritedef.scale.y;
		sprite.anchor.x=0.5;
		sprite.anchor.y=0.5;
		sprite.loop=spritedef.loop;
		sprite.looped=0;
		sprite.position={x:spritedef.position.x,y:spritedef.position.y};

		this.sprites.push(sprite);
		this.stage.addChild(sprite);
	},
	
	addspriteimage:function(spritedef) {
		var sprite=new PIXI.Sprite(PIXI.loader.resources[spritedef.image].texture);
		sprite.scale.x=spritedef.scale.x;
		sprite.scale.y=spritedef.scale.y;

		sprite.position={x:spritedef.position.x,y:spritedef.position.y};
		sprite.stopped=true;
		this.sprites.push(sprite);
		this.stage.addChild(sprite);
		return sprite;
	},
	
	clear:function() {
		this.stage.removeChildren();
		for(var a in this.sprites) {
			this.sprites[a]=null;
		}
		this.sprites=[];
		this.renderer.render(this.stage);
	},
	
	animate:function() {
		this.play=true;
		requestAnimationFrame(this.update);
	},
	
	stop:function() {
		this.play=false;
	}
};

animation.init();


app.initialize();




var getqs=function(key) {
		var qst=window.location.search.substring(1).split('&');
		var re=new RegExp(key);
		for(var z in qst) {
			if(re.test(qst[z])) {	
				var sp=qst[z].split('=');
				return sp[1];
			}
		}
		
		return false;
	};

/* function to resize the window after loading; used for testing in web browser */
function websize() {
	var chrome=46; //chrome offset for Safari=61. Small window chrome=46
	var wchrome=0; // 320x480=4:3, 320x568=HD, 853x640=iPad, 320x533=Android
	
	
	var w=parseInt(getqs('w'));
	var h=parseInt(getqs('h'));
	if(!w) w=320;
	if(!h) h=533;
	
	
	window.resizeTo(w+wchrome,h+chrome);

	app.getsize(); // resize app
}



var testnextavatar=function() {
	// bring in the next avatar
		var l=user.loaddata('overall','totalmissions');
		var ul=user.loaddata('overall','level');
		
		if(!ul) {
			ul=0;
		}
		if(!l) {
			l=0;
		}
		l=parseInt(l);
		ul=parseInt(ul);
		var currentbadge=config.badgelevels[ul];
		if(currentbadge.id=='ultimate') {nav.home();return;}

		var nextbadge=config.badgelevels[parseInt(ul)+1];
		var lastbadge=config.badgelevels[parseInt(ul)-1];
		var tm=nextbadge.m;
		user.savedata('overall',"totalmissions",tm);
		user.savedata('overall','level',parseInt(ul)+1);

		
		var sw=document.getElementById('animlayer');
		changeclass(sw,'move',true);
		
		var thisbg=document.getElementById('cbg');
		var nextbg=document.getElementById('complete');
		
		changeclass(thisbg,'fade',true);
		changeclass(thisbg,'hidden',true);
		changeclass(thisbg,'bg-' + lastbadge.bg,true);
		changeclass(thisbg,'bg-' + currentbadge.bg);

		changeclass(nextbg,'bg-' + currentbadge.bg,true);
		changeclass(nextbg,'bg-' + nextbadge.bg);
		cards.changeavatar(currentbadge,nextbadge);
};

// data ready for 
if(!window.cordova) {

	var testbadges=getqs('badges');
	if(testbadges==1) {
		config.badgelevels=config.badgelevelsfaster;
	} else if(testbadges==2) {
		config.badgelevels=config.badgelevelsq;
	}
	
	var getsampledata=getqs('sample');
	if(getsampledata) {	
		setTimeout(function() {loadtestdata('../test/testdata.json',gottestdata);},500);
	}

	    Trampoline.init(config.trampolineconfig);
 

}
         
         Trampoline.events.addEventListener('SPLASH_DONE',function() {
			Trampoline.state.change({to: "main"});
			nav.splash();}
			);
        



var lasttarget,lastco,newco,scrolling,stopscroll;


var showmoreapps=function() {	

	Trampoline.state.change({to: 'moreApps', from: 'main'});
};

var showpbssettings=function() {	

	Trampoline.state.change({to: 'settings', from: 'main'});
};


var clickdown=function(ev) {
	if(scrolling) return;

	lasttarget=ev.currentTarget;
	lastco=newco=app.getcoords(ev);

};

var clickmove=function(ev) {
	if(lasttarget==ev.currentTarget) {
		newco=app.getcoords(ev);

	}
};

var noscroll=function() {
	scrolling=false;
};

var scrollshift=0;
var headersize=0;
var watchscroll;
var scrollloc;

var inscroll=function(ev) {
		scrolling=true;
		clearTimeout(stopscroll);
		
		checkscroll();
		stopscroll=setTimeout(noscroll,200);
};

var pastscroll=function(truefalse,scrolldom) {
	if(!scrolldom) {
		scrolldom=panel.content.dom;
	}
	changeclass(scrolldom,"pastscroll",!truefalse);
	changeclass(panel.bottomnav.dom,"pastscroll",!truefalse);
};



var checkscroll=function() {
// check when the scroll is flung?
	clearTimeout(watchscroll);
	var keepchecking=false;
	if(scrollshift) {
	var newpos=scrollobj.t.getBoundingClientRect().top - scrollobj.c.getBoundingClientRect().top;
		if(scrollloc!=newpos) {

			scrollloc=newpos;
			keepchecking=true;
			if(scrollobj.t.getBoundingClientRect().top - scrollobj.c.getBoundingClientRect().top < scrollshift) {
				pastscroll(true,scrollobj.c);
			} else {
				pastscroll(false,scrollobj.c);
			}
		}
	}
};

var clickup=function(ev) {

	if(scrolling) return;
	if(lasttarget==ev.currentTarget) {
		var dist=(newco.x-lastco.x)*(newco.x-lastco.x) + (newco.y-lastco.y)*(newco.y-lastco.y);
		var range=ev.currentTarget.clickrange?ev.currentTarget.clickrange:250;
		if(dist < range) {
			ev.currentTarget.dispatchEvent(clickevent);
		}
	}
	lasttarget=null;
};


var introanimation={
	/*
	Stack bg, Gabi (close on ladybug)
	1. closeup on Gabi
	2. pull back to show bg
	3. stop; add title (~2s)
	4. add ship w/window covering all, at size containing entire screen. Scale/move to place window in upper right corner
	*/
	gabi:{},
	bg:{},
	title:{},
	ship:{},
	end:{}, // end positions
	
	load:function() {
		var loadarray=[];
		this.movetotitle=this.movetotitle.bind(this);
		this.movetoship=this.movetoship.bind(this);
		
		animation.clear();
		animation.resize(app.width,app.height);
		document.getElementById('intro').appendChild(animation.dom);
		
		for(var i in config.intro.set) {
			var im=config.intro.set[i];
			var pre=this.imagesrc(config.intro[im].image);
			if(!animation.alreadyloaded(pre)){
					loadarray.push(pre);
			}
		}
		
		var me=this;
		if(loadarray.length <1) {
			me.start();
		} else {
			animation.load(loadarray, function() {me.start();});
		}	
	},
	
	imagesrc:function(imagename) {
		return "img/intro/" + imagename + ".png";
	},
	
	start:function() {
		// scale/position Gabi so that ladybug and Gabi's eye are both visible
		var g=config.intro.gabi;
		var gscale=app.height/g.ladybug.h;
		var gabiscale={x:gscale,y:gscale};
		var gscaleend=0.5*app.height/g.h;
		var gabipos={x:0,y:gscale*-1*g.ladybug.y};
		var gabiposend={x:0,y:(app.height/2 + (g.h*gscaleend*0.20))};

		// scale bg to fill screen top to bottom
		var bg=config.intro.background;
		var bgposend={x:0,y:0};
		var fitbg=app.height/bg.h;
		var startbg=0.5*fitbg*(gscale/gscaleend);
		var bgpos={x:0,y:-0.5*startbg*bg.h};
		var bgscale={x:startbg,y:startbg};
		
		index.bgs.outside={
				scale:fitbg,
				size:{x:fitbg*bg.w,y:fitbg*bg.h},
				pos:{x:0,y:0}
			};
		
		 this.bg=animation.addspriteimage({"image":this.imagesrc(bg.image),position:bgpos,scale:bgscale});

		
		this.gabi=animation.addspriteimage({"image":this.imagesrc(g.image),position:gabipos,scale:gabiscale});
	
		var time=2000;
		var me=this;
		setTimeout(function() {

		// scale down Gabi to simulate moving back. Leave room above Gabi for title. Scale bg also. At end, show title.
		new tween().start(me.gabi.scale,'x',gscale,gscaleend,time);
		new tween().start(me.gabi.scale,'y',gscale,gscaleend,time);
		new tween().start(me.gabi.position,'x',gabipos.x,gabiposend.x,time);
		new tween().start(me.gabi.position,'y',gabipos.y,gabiposend.y,time);
		
		
		new tween().start(me.bg.scale,'x',startbg,fitbg,time);
		new tween().start(me.bg.scale,'y',startbg,fitbg,time);
		new tween().start(me.bg.position,'x',bgpos.x,bgposend.x,time);
		new tween().start(me.bg.position,'y',bgpos.y,bgposend.y,time);
		setTimeout(me.movetotitle,time);
		
		},500);
		
		animation.animate();
	},
	
	movetotitle:function() {
		this.movetoship=this.movetoship.bind(this);
		
		taketaps(document.getElementById('intro'),'click',this.movetoship);
		document.getElementById('intro').clicksound='click';
		changeclass(document.getElementById('startup'),'nonav',true);
		
		var title=config.intro.title;
		var titlepos={x:0.05*app.width,y:0.1*app.height};
		var startscale=0.9*app.width/title.w;
		var titlescale={x:startscale,y:startscale};
		
		this.title=animation.addspriteimage({"image":this.imagesrc(title.image),position:titlepos,scale:titlescale});
		
		var playbtn=document.createElement('img');
		playbtn.src="img/intro/play_button.svg";
		playbtn.id="startbutton";
		
		document.getElementById('intro').insertBefore(playbtn,document.getElementById('animationview'));
	},
	movetoship:function() {
		// frame all with ship window. Scale/move to position ship window in upper right.
		
		document.getElementById('intro').removeChild(document.getElementById('startbutton'));
		
		cleartaps(document.getElementById('intro'),'click',this.movetoship);
		changeclass(document.getElementById('startup'),'hidden');
		var me=this;
		var ship=config.intro.ship;
		var startscale=app.height/ship.window.h;
		var shippos={x:(ship.window.x*startscale*-1),y:ship.window.y*startscale*-1};
		var shipscale={x:startscale,y:startscale};
		
		var endscale=app.height/(ship.h-(ship.window.y + ship.window.h*0.5));



			var osc=index.bgs.outside.scale;
			var ssc=endscale;
			var poi=config.intro.poi[0];
			var x=poi[0]*-1*osc + app.width - (ssc*config.intro.ship.window.w/2);
			var y=poi[1]*-1*osc + (ssc*config.intro.ship.window.h/2);

		var shipposend={x:((ship.window.x+ship.window.w*0.5)*endscale*-1)+app.width,y:(ship.window.y)*endscale*-1};
		this.ship=animation.addspriteimage({"image":this.imagesrc(ship.image),position:shippos,scale:shipscale});
		var time=2000;
		
		new tween().start(me.ship.scale,'x',startscale,endscale,time);
		new tween().start(me.ship.scale,'y',startscale,endscale,time);
		new tween().start(me.ship.position,'x',shippos.x,shipposend.x,time);
		new tween().start(me.ship.position,'y',shippos.y,shipposend.y,time);


		var titleposend={x:me.title.position.x-app.width*1.3};
		var gabiposend={x:me.gabi.position.x-app.width/1.1};

		var bgposend={x:x,y:y};

		new tween().start(me.title.position,'x',me.title.position.x,titleposend.x,time);
		
		new tween().start(me.gabi.position,'x',me.gabi.position.x,gabiposend.x,time);
		
		new tween().start(me.bg.position,'x',me.bg.position.x,bgposend.x,time);
		new tween().start(me.bg.position,'y',me.bg.position.x,bgposend.y,time);



		index.bgs.ship={
				scale:endscale,
				size:{x:ship.w*endscale,y:ship.h*endscale},
				pos:{x:parseInt(shipposend.x),y:parseInt(shipposend.y)}
			};
	
		index.bgs.outside.pos={x:parseInt(bgposend.x),y:parseInt(bgposend.y)};


		setTimeout(function() {
			me.done();
			nav.home();
		},time);
	},
	done:function() {
		animation.stop();
		animation.clear();
	}
};

function clickedbackbutton(ev) {
	nav.back();
}

var track=function(type,input) {
	// Analytics

	// movement through the app is just pageview ype
	if(typeof ga=='undefined') return;
	switch (type) {
		case 'pageview':
			ga('set', 'page',input);
			ga('send',"pageview");
		break;
		
		case 'event':
			var ob={hitType:'event', eventCategory:input.category,eventAction:input.action};
			
			if(input.label) ob.eventLabel=input.label;
			if(input.value) ob.eventValue=input.value;
			
			ga('send',ob); // usually: object, type of interaction, categorization
		
		break;
	}

};




/* TEMPLATES */


var templates={
	reg:/%%([^%]+)%%/igm,
	parse:function(str,subs,vals) {
	// should do some substitutions - replace any %%key%% with result of the function in templates.subs[key]
	
	if(!subs) {
		subs=templates.subs;
	}
		if(subs && templates.reg.test(str)) {
			// has at least one substitution
			str=str.replace(templates.reg,function(m){
				m=m.replace(/%%/g,'');
				var f=subs[m];
				if(f==='load') {
					return templates.loadhtml(m);
				} else if(f==='val') {
					return vals[m];
				} else {
					return f(m);
				}
				});
		}
	
		return str;
	},
	
	fillhtml:function(htmlfile,data) {
		var d=document.getElementById('file_' + htmlfile);
		if(d && data) {
			d.innerHTML=data;
		}
		window.dispatchEvent(new CustomEvent("loaded", 
		{
			detail:{'file':htmlfile},
			bubbles: true,
			cancelable: true
		}));
	
	},
	
	loadhtml:function(htmlfile) {
		// put a placeholder div in that will get filled on AJAX return
		var rq=new XMLHttpRequest();
		var me=this;
		rq.open("GET","html/"+htmlfile +".html",true);
		rq.onreadystatechange=function() {
			if(rq.readyState === XMLHttpRequest.DONE) {
			me.fillhtml(htmlfile,rq.responseText);
			}
		};
		rq.send();
		return "<div id=\"file_"+htmlfile+"\"/>";
	},
	
	setsubs:function(config) {
		for(var k in config) {
			templates.subs[k]=config[k];
		}
	},
	
	blank:{html:''},
	
	cardbody:{
	html:'<div class="cardtext"><h2 class="acttitle">%%title%%</h2><div class="actdesc" id="%%id%%_desc"><p>%%desc%%</p></div><img class="fadecover hidden" id="fade_%%id%%" src="img/whitefade.png"/></div><div class="cardbuttons"><button id="start_%%id%%" class="cardbutton"><button id="results_%%id%%" data-mid="%%id%%" class="cardbutton seeresults hidden bg-green"><img src="img/icon_carousel_gallery.svg" class="galleryicon" alt="gallery" /></button></div></div>',
	subs:{
		id:cards.currentid,
		title:app.missionproperty,
		desc:app.missionproperty
	}
	},
	
	singlecard:{
		html:'<div id=\"allcards\" class=\"cardset single transit\">%%id%%</div>',
	
		subs:{
			id:cards.makecard
		}
	},
	
// card states
	completed:{

		
		html:'<div id="complete" class="complete"><div id="cbg" class="hidden"></div><div id="%%id%%"><div class="ctr">%%progress%%<div id="progmessage"><div id="goodjob"></div><div id="avatarname"></div></div></div><div id="animlayer"></div><div id="finishedblurb"><h2>%%completemessage%%</h2>%%results%%</div></div><div id="okbutton"><button id="okay" class="hidden">Okay</button></div>',
		
		buttons:{
		},
		subs:{
			id:cards.currentid,
			title:app.missionproperty,
			results:cards.currentresults,
			progress:progressbar,
			completemessage:user.completemessage
		}
		
	},
	


// nav buttons
	carousel:{
		html:'<div class="f1_4 col vctr"><div class="f1_1 lj"><button id="arrowleft" class="ctr nobg fit"><img src="img/carousel_arrow_left.svg" alt="previous" width="30" height="50"  class="carouselarrow" /></button></div></div>\n<div class="f1_2 col vctr"><div class="f1_1 fullctr" id="carddots"></div></div>\
		<div class="f1_4 col vctr"><div class="f1_1 rj"><button id="arrowright" class="ctr nobg fit"><img src="img/carousel_arrow_right.svg" alt="next" width="30" height="50" class="carouselarrow" /></button></div></div>',
		
		buttons:{
			'arrowright':{'tap':cards.nextcard},
			'arrowleft':{'tap':cards.prevcard}
		}
	},
	edit:{
		html:'<div class="f1_1 col vctr"><button id="btn-edit" class="bg-green f1_4 bottombutton">Edit</button></div>',
		buttons:{
			'btn-edit':{'tap':listview.editmode}
		}
	},
	
	top:{
		html:'<div class="floatingtop bg-grey"><a class="button bg-green" id="totop" href="#top">&#9650; Top</a></div>',
		nobg:true,
		buttons:{
			'totop':{'tap':nav.clicktop}
		}
	},

	activity:{
		html:'<div class="f1_2 col vctr"><button id="btn-close" class="bottombutton bg-green f3_4">Save Progress</button></div>\
		<div class="f1_2 col vctr"><div class="f1_1 rj"><button id="btn-complete" class="bottombutton bg-green f3_4"><img src="img/checkmark.svg" alt="check" class="icon completecheck" />Complete</button></div></div>',
		
		buttons:{
			'btn-close':{'tap':cards.donefornow}/*,
			'btn-complete':{'tap':cards.done}*/
			}
	},
	
	okay: {
			html:'<div class="f2_3 col">&nbsp;</div>\
		<div class="f1_3 col fullctr"><div class="f1_1 rj"><button id="okay" class="f5_6 hidden">Okay</button></div></div>',
		buttons:{
			'okay':{'tap':nav.home}
		}
	},
	
// splash
	splash:{
		html:'<div id="logos" class="logobg fullctr"><img id="logoimage" src="img/WGBH_Kids_color_cmyk.svg" alt="WGBH Kids" /></img></div>'
		
	},
	
	intro:{
		html:'<div id="intro"></div>'
	},
	
// homepage
	index:{
		html:'<div id="index"><div id="ship"><div id="indextop"><button class="nobg" id="parentinfo"><img  src="img/info_icon_green.svg" height="30" width="30" alt="Info for parents" /></button></div>\
		<div id="dashboard">[ DASHBOARD ]</div>\
		<div id="indexbuttons"><div class="f1_1 vspread"><h2 class="ondark">Missions</h2><button class="ctr bigbutton" id="todaymissions">Today<div id="today"></div></button><button class="ctr bigbutton bg-green" id="inprogress">In Progress</button><button class="ctr bg-green bigbutton" id="allmissions">All</button></div></div></div></div>',
		
		buttons:{
			'parentinfo':{'tap':nav.parents}
		}
	},

// list 
	list:{
		html:'<div id="headers" class="vcenter hidden"></div><div id="list" class="scroll">%%list%%</div><div id="edit"></div>',
		alltitle:'<div class="listtitle listtitle_all" id="listtitle"><h1>All Missions</h1></div><img src="img/plum_all_missions.svg" width="182" height="146" alt="plum" class="ctr listplum" />',
		progresstitle:'<div class="listtitle listtitle_progress" id="listtitle"><h1>Missions in Progress</h1></div><img src="img/plum_in_progress.svg" width="111" height="128" alt="plum" class="ctr listplum" />',
		completedtitle:'<div class="listtitle listtitle_complete" id="listtitle"><div class="badgetop">%%showbadge%%<div id="ouractivitytop"><h1>Our Progress</h1><p id="encourage">%%encouragement%%</p></div></div><div>%%dash%%</div></div>',
		
	subs:{
		list:listview.activitylist,
		dash:progressbar,
		showbadge:user.maybebadge,
		encouragement:user.encouragement
	},
	scrollshift:{
		all:-200,
		progress:-200,
		complete:-240
	}
	},
	
	badge:{
		html:'<div class="numberbadge"><img src="%%badge%%" width="110" height="125" class="bigbadge"/><div class="badgenumber">%%badgenum%%</div></div>',
		
		subs:{		
			badge:user.getbadgeimage,
			badgenum:user.getbadgenumber
		}
	},


	gallery:{
		html:'<div id="galleryname"></div><div id="glist" class="scroll">%%list%%</div>',
		scrolltitle:'<div class="listtitle listtitle_gallery" id="listtitle"></div>',
		title:'<h1 id="gallerytitle">%%title%%</h1>',
		
		scrollshift:0,
		headersize:0,
		
	subs:{
		list:listview.gallerylist,
		title:app.missionproperty
		}
	},

// tools
	camera:{
		html:'\
		<div id="toprow"><div class="f3_4 col fullctr fullheight"><div class="f1_5 col fullctr photoholder"><button id="p1" class="nobg photothumb"><div class="thumbh"><img id="i1" src="img/photo_icon_empty.svg" alt="" class="thumbnail" /></div></button></div> <div class="f1_5 col fullctr photoholder"><button id="p2" class="nobg photothumb"><div class="thumbh"><img id="i2" src="img/photo_icon_empty.svg" alt="" class="thumbnail" /></div></button></div><div class="f1_5 col fullctr photoholder"><button id="p3" class="nobg photothumb"><div class="thumbh"><img id="i3" src="img/photo_icon_empty.svg" alt=""  class="thumbnail" /></div></button></div><div class="f1_5 col fullctr photoholder"><button id="p4" class="nobg photothumb"><div class="thumbh"><img id="i4" src="img/photo_icon_empty.svg" alt="" class="thumbnail" /></div></button></div><div class="f1_5 col fullctr photoholder"><button id="p5" class="nobg photothumb"><div class="thumbh"><img id="i5" src="img/photo_icon_empty.svg" alt="" class="thumbnail" /></div></button></div></div>\
		<div class="col f1_4 fullctr"><div class="f1_1 rj"><button id="camera" class="toolbutton"><img src="img/all_missions_camera.svg" alt="camera" class="toolicon" /></button></div></div></div>\
		<div class="f1_1 col ctr"><img id="ilarge" /></div>',
		
		buttons:{
			'camera':{'tap':tools.camera.showcamera,'clicksound':'click'},
			'p1':{'tap':tools.camera.enlarge},
			'i1':{},
			'p2':{'tap':tools.camera.enlarge},
			'i2':{},
			'p3':{'tap':tools.camera.enlarge},
			'i3':{},
			'p4':{'tap':tools.camera.enlarge},
			'i4':{},
			'p5':{'tap':tools.camera.enlarge},
			'i5':{},
			
			'ilarge':{}
		}
	},
	
	counter:{
		html:'<div id="toprow"><div class="f3_4 col fullctr">\
		<div class="f1_1 col fullctr"><div id="summary"></div></div></div>\
		<div class="f1_4 col fullctr"><div class="f1_1 rj"><button id="open" class="toolbutton"><img class="toolicon" src="img/all_missions_counter.svg" alt="open" /></button></div></div></div>\
		<div class="f1_1 col"><div class="ctr">%%counthero%%</div>\
		<div class="f1_1 toolbottom"><div class="f1_3 col"><button id="minus" class="ctr circle bg-green"><img src="img/minus.svg" class="toolicon" alt="subtract" width="35" height="35" /></button></div><div class="f1_3 col"><div id="cdisplay" class="large lining ctr tooldisplay f4_5">0</div></div><div class="f1_3 col"><button id="plus" class="toolbutton ctr"><img src="img/plus.svg" class="toolicon" alt="add" width="40" height="40" /></button></div></div></div>',

		buttons:{
			'minus':{'tap':tools.counter.subtract,'clicksound':'countdown'},
			'open':{'tap':tools.counter.open,'clicksound':'click'},
			'plus':{'tap':tools.counter.add,'clicksound':'countup'},
			'cdisplay':{}
		},
		subs:{
			'counthero':tools.counter.heroimage
		}
	},
	
	
	scavenger:{
		html:'<div id="toprow"><div class="f3_4 col vctr">%%status%%</div><div class="f1_4 col vctr"><div class="f1_1 rj"><button id="openlist" class="bg-orange re toolbutton"><img src="img/all_missions_scavenger.svg" class="toolicon" alt="open" /></button></div></div></div>\
		<div class="f1_1 col" id="huntsection"><h1 class="scavtitle">%%title%%</h1>%%list%%</div>',
		buttons:{
			'openlist':{'tap':tools.scavenger.showlist,'clicksound':'click'}
		},
		subs:{
			'list':tools.scavenger.lookuplist,
			'status':tools.scavenger.statushtml,
			'title':app.missionproperty
		}
	},
	
	stats:{
		html:'<div id="list" class="scroll"></div>'
	},
	
	parents:{
		html:'<div class="scroll" id="parentscroll">%%parentshtml%%</div>',
		subs:{'parentshtml':'load'},
		scrollshift:-90

	}
};


templates.loaded=new CustomEvent("loaded", 
	{
		bubbles: true,
		cancelable: true
	}
);

